type token =
  | TUnknown of (Ast_c.info)
  | TCommentSpace of (Ast_c.info)
  | TCommentNewline of (Ast_c.info)
  | TComment of (Ast_c.info)
  | TInt of ((string * (Ast_c.sign * Ast_c.base)) * Ast_c.info)
  | TFloat of ((string * Ast_c.floatType) * Ast_c.info)
  | TChar of ((string * Ast_c.isWchar) * Ast_c.info)
  | TString of ((string * Ast_c.isWchar) * Ast_c.info)
  | TQuote of ((string * Ast_c.isWchar) * Ast_c.info)
  | TPct of (Ast_c.info)
  | TFormat of (string * Ast_c.info)
  | TSubString of (string * Ast_c.info)
  | TDecimal of ((string * string (*n*) * string (*p*)) * Ast_c.info)
  | TIdent of (string * Ast_c.info)
  | TKRParam of (string * Ast_c.info)
  | Tconstructorname of (string * Ast_c.info)
  | TypedefIdent of (string * Ast_c.info)
  | TOPar of (Ast_c.info)
  | TCPar of (Ast_c.info)
  | TOBrace of (Ast_c.info)
  | TCBrace of (Ast_c.info)
  | TOCro of (Ast_c.info)
  | TCCro of (Ast_c.info)
  | TDot of (Ast_c.info)
  | TComma of (Ast_c.info)
  | TPtrOp of (Ast_c.info)
  | TInc of (Ast_c.info)
  | TDec of (Ast_c.info)
  | TAssign of (Ast_c.assignOp * Ast_c.info)
  | TEq of (Ast_c.info)
  | TWhy of (Ast_c.info)
  | TTilde of (Ast_c.info)
  | TBang of (Ast_c.info)
  | TEllipsis of (Ast_c.info)
  | TDotDot of (Ast_c.info)
  | TPtVirg of (Ast_c.info)
  | TOrLog of (Ast_c.info)
  | TAndLog of (Ast_c.info)
  | TOr of (Ast_c.info)
  | TXor of (Ast_c.info)
  | TAnd of (Ast_c.info)
  | TEqEq of (Ast_c.info)
  | TNotEq of (Ast_c.info)
  | TInf of (Ast_c.info)
  | TSup of (Ast_c.info)
  | TInfEq of (Ast_c.info)
  | TSupEq of (Ast_c.info)
  | TShl of (Ast_c.info)
  | TShr of (Ast_c.info)
  | TPlus of (Ast_c.info)
  | TMinus of (Ast_c.info)
  | TMul of (Ast_c.info)
  | TDiv of (Ast_c.info)
  | TMod of (Ast_c.info)
  | TMax of (Ast_c.info)
  | TMin of (Ast_c.info)
  | Tchar of (Ast_c.info)
  | Tshort of (Ast_c.info)
  | Tint of (Ast_c.info)
  | Tdouble of (Ast_c.info)
  | Tfloat of (Ast_c.info)
  | Tlong of (Ast_c.info)
  | Tunsigned of (Ast_c.info)
  | Tsigned of (Ast_c.info)
  | Tvoid of (Ast_c.info)
  | Tsize_t of (Ast_c.info)
  | Tssize_t of (Ast_c.info)
  | Tptrdiff_t of (Ast_c.info)
  | Tauto of (Ast_c.info)
  | Tregister of (Ast_c.info)
  | Textern of (Ast_c.info)
  | Tstatic of (Ast_c.info)
  | Ttypedef of (Ast_c.info)
  | Tconst of (Ast_c.info)
  | Tvolatile of (Ast_c.info)
  | Tstruct of (Ast_c.info)
  | Tunion of (Ast_c.info)
  | Tenum of (Ast_c.info)
  | Tdecimal of (Ast_c.info)
  | Tbreak of (Ast_c.info)
  | Telse of (Ast_c.info)
  | Tswitch of (Ast_c.info)
  | Tcase of (Ast_c.info)
  | Tcontinue of (Ast_c.info)
  | Tfor of (Ast_c.info)
  | Tdo of (Ast_c.info)
  | Tif of (Ast_c.info)
  | Twhile of (Ast_c.info)
  | Treturn of (Ast_c.info)
  | Tgoto of (Ast_c.info)
  | Tdefault of (Ast_c.info)
  | Tsizeof of (Ast_c.info)
  | Tnew of (Ast_c.info)
  | Tdelete of (Ast_c.info)
  | TOParCplusplusInit of (Ast_c.info)
  | Tnamespace of (Ast_c.info)
  | Trestrict of (Ast_c.info)
  | Tasm of (Ast_c.info)
  | Tattribute of (Ast_c.info)
  | TattributeNoarg of (Ast_c.info)
  | Tinline of (Ast_c.info)
  | Ttypeof of (Ast_c.info)
  | TDefine of (Ast_c.info)
  | TDefParamVariadic of ((string * Ast_c.info))
  | TCppEscapedNewline of (Ast_c.info)
  | TCppConcatOp of (Ast_c.info)
  | TOParDefine of (Ast_c.info)
  | TOBraceDefineInit of (Ast_c.info)
  | TIdentDefine of ((string * Ast_c.info))
  | TDefEOL of (Ast_c.info)
  | TInclude of ((string * string * bool ref * Ast_c.info))
  | TIncludeStart of ((Ast_c.info * bool ref))
  | TIncludeFilename of ((string * Ast_c.info))
  | TIfdef of (((int * int) option ref * Ast_c.info))
  | TIfdefelse of (((int * int) option ref * Ast_c.info))
  | TIfdefelif of (((int * int) option ref * Ast_c.info))
  | TEndif of (((int * int) option ref * Ast_c.info))
  | TIfdefBool of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefMisc of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefVersion of ((bool * (int * int) option ref * Ast_c.info))
  | TUndef of (Ast_c.info)
  | TPragma of (Ast_c.info)
  | TCppDirectiveOther of (Ast_c.info)
  | TMacroAttr of ((string * Ast_c.info))
  | TMacroStmt of ((string * Ast_c.info))
  | TMacroIdentBuilder of ((string * Ast_c.info))
  | TMacroString of ((string * Ast_c.info))
  | TMacroDecl of ((string * Ast_c.info))
  | TMacroDeclConst of (Ast_c.info)
  | TMacroIterator of ((string * Ast_c.info))
  | TMacroAttrStorage of ((string * Ast_c.info))
  | TCommentSkipTagStart of (Ast_c.info)
  | TCommentSkipTagEnd of (Ast_c.info)
  | TCParEOL of (Ast_c.info)
  | TAction of (Ast_c.info)
  | TCommentMisc of (Ast_c.info)
  | TCommentCpp of ((Token_c.cppcommentkind * Ast_c.info))
  | EOF of (Ast_c.info)

open Parsing;;
let _ = parse_error;;
# 25 "parser_c.mly"
(* Yoann Padioleau
 *
 * Copyright (C) 2002, 2006, 2007, 2008, 2009 Yoann Padioleau
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License (GPL)
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * file license.txt for more details.
 *)
open Common

open Ast_c

module LP = Lexer_parser
open Lexer_parser (* for the fields *)

open Semantic_c (* Semantic exn *)
module T = Token_c

(*****************************************************************************)
(* Wrappers *)
(*****************************************************************************)
let warning s v =
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ s) v
  else v

let pr2, pr2_once = Common.mk_pr2_wrappers Flag_parsing_c.verbose_parsing

(*****************************************************************************)
(* Parse helpers functions *)
(*****************************************************************************)

(*-------------------------------------------------------------------------- *)
(* Type related *)
(*-------------------------------------------------------------------------- *)

type shortLong      = Short  | Long | LongLong

type decl = {
  storageD: storagebis wrap;
  typeD: ((sign option) * (shortLong option) * (typeCbis option)) wrap;
  qualifD: typeQualifierbis wrap;
  inlineD: bool             wrap;
  (* note: have a full_info: parse_info list; to remember ordering
   * between storage, qualifier, type ? well this info is already in
   * the Ast_c.info, just have to sort them to get good order *)
}

let nullDecl = {
  storageD = NoSto, [];
  typeD = (None, None, None), [];
  qualifD = nullQualif;
  inlineD = false, [];
}
let fake_pi = Common.fake_parse_info

let addStorageD  = function
  | ((x,ii), ({storageD = (NoSto,[])} as v)) -> { v with storageD = (x, [ii]) }
  | ((x,ii), ({storageD = (y, ii2)} as v)) ->
      if x =*= y then warning "duplicate storage classes" v
      else raise (Semantic ("multiple storage classes", fake_pi))

let addInlineD  = function
  | ((true,ii), ({inlineD = (false,[])} as v)) -> { v with inlineD=(true,[ii])}
  | ((true,ii), ({inlineD = (true, ii2)} as v)) -> warning "duplicate inline" v
  | _ -> raise (Impossible 86)


let addTypeD     = function
  | ((Left3 Signed,ii)   ,({typeD = ((Some Signed,  b,c),ii2)} as v)) ->
      warning "duplicate 'signed'"   v
  | ((Left3 UnSigned,ii) ,({typeD = ((Some UnSigned,b,c),ii2)} as v)) ->
      warning "duplicate 'unsigned'" v
  | ((Left3 _,ii),        ({typeD = ((Some _,b,c),ii2)} as _v)) ->
      raise (Semantic ("both signed and unsigned specified", fake_pi))
  | ((Left3 x,ii),        ({typeD = ((None,b,c),ii2)} as v))   ->
      {v with typeD = (Some x,b,c),ii ++ ii2}

  | ((Middle3 Short,ii),  ({typeD = ((a,Some Short,c),ii2)} as v)) ->
      warning "duplicate 'short'" v


  (* gccext: long long allowed *)
  | ((Middle3 Long,ii),   ({typeD = ((a,Some Long ,c),ii2)} as v)) ->
      { v with typeD = (a, Some LongLong, c),ii++ii2 }
  | ((Middle3 Long,ii),   ({typeD = ((a,Some LongLong ,c),ii2)} as v)) ->
      warning "triplicate 'long'" v


  | ((Middle3 _,ii),      ({typeD = ((a,Some _,c),ii2)} as _v)) ->
      raise (Semantic ("both long and short specified", fake_pi))
  | ((Middle3 x,ii),      ({typeD = ((a,None,c),ii2)} as v))  ->
      {v with typeD = (a, Some x,c),ii++ii2}

  | ((Right3 t,ii),       ({typeD = ((a,b,Some x),ii2)} as _v)) ->
      raise (Semantic ((Printf.sprintf "two or more data types: t %s ii %s\ntypeD %s ii2 %s\n" (Dumper.dump t) (Dumper.dump ii) (Dumper.dump x) (Dumper.dump ii2)), fake_pi))
  | ((Right3 t,ii),       ({typeD = ((a,b,None),ii2)} as v))   ->
      {v with typeD = (a,b, Some t),ii++ii2}


let addQualif = function
  | ({const=true},   ({const=true} as x)) ->   warning "duplicate 'const'" x
  | ({volatile=true},({volatile=true} as x))-> warning "duplicate 'volatile'" x
  | ({const=true},    v) -> {v with const=true}
  | ({volatile=true}, v) -> {v with volatile=true}
  | _ ->
      internal_error "there is no noconst or novolatile keyword"

let addQualifD ((qu,ii), ({qualifD = (v,ii2)} as x)) =
  { x with qualifD = (addQualif (qu, v),ii::ii2) }


(*-------------------------------------------------------------------------- *)
(* Declaration/Function related *)
(*-------------------------------------------------------------------------- *)


(* stdC: type section, basic integer types (and ritchie)
 * To understand the code, just look at the result (right part of the PM)
 * and go back.
 *)
let (fixDeclSpecForDecl: decl -> (fullType * (storage wrap)))  = function
 {storageD = (st,iist);
  qualifD = (qu,iiq);
  typeD = (ty,iit);
  inlineD = (inline,iinl);
  } ->
   let ty',iit' =
   (match ty with
 | (None,None,None)       ->
     (* generate fake_info, otherwise type_annotater can crash in
      * offset.
      *)
     warning "type defaults to 'int'" (defaultInt, [fakeInfo fake_pi])
 | (None, None, Some t)   -> (t, iit)

 | (Some sign,   None, (None| Some (BaseType (IntType (Si (_,CInt))))))  ->
     BaseType(IntType (Si (sign, CInt))), iit
 | ((None|Some Signed),Some x,(None|Some(BaseType(IntType (Si (_,CInt)))))) ->
     BaseType(IntType (Si (Signed, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some UnSigned, Some x, (None| Some (BaseType (IntType (Si (_,CInt))))))->
     BaseType(IntType (Si (UnSigned, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some sign,   None, (Some (BaseType (IntType CChar))))   ->
     BaseType(IntType (Si (sign, CChar2))), iit
 | (None, Some Long,(Some(BaseType(FloatType CDouble))))    ->
     BaseType (FloatType (CLongDouble)), iit

 | (Some _,_, Some _) ->
     (*mine*)
     raise (Semantic ("signed, unsigned valid only for char and int", fake_pi))
 | (_,Some _,(Some(BaseType(FloatType (CFloat|CLongDouble))))) ->
     raise (Semantic ("long or short specified with floating type", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDouble)))) ->
     raise (Semantic ("the only valid combination is long double", fake_pi))

 | (_, Some _, Some _) ->
     (* mine *)
     raise (Semantic ("long, short valid only for int or float", fake_pi))

     (* if do short uint i, then gcc say parse error, strange ? it is
      * not a parse error, it is just that we dont allow with typedef
      * either short/long or signed/unsigned. In fact, with
      * parse_typedef_fix2 (with et() and dt()) now I say too parse
      * error so this code is executed only when do short struct
      * {....} and never with a typedef cos now we parse short uint i
      * as short ident ident => parse error (cos after first short i
      * pass in dt() mode) *)

   )
   in
   ((qu, iiq),
   (ty', iit'))
     ,((st, inline),iist++iinl)


let fixDeclSpecForParam = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | (Sto Register) -> (v, true), iist
  | NoSto -> (v, false), iist
  | _ ->
      raise
        (Semantic ("storage class specified for parameter of function",
                  fake_pi))

let fixDeclSpecForMacro = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | NoSto -> v
  | _ ->
      raise
        (Semantic ("storage class specified for macro type decl",
                  fake_pi))


let fixDeclSpecForFuncDef x =
  let (returnType,storage) = fixDeclSpecForDecl x in
  (match fst (unwrap storage) with
  | StoTypedef ->
      raise (Semantic ("function definition declared 'typedef'", fake_pi))
  | _ -> (returnType, storage)
  )


(* parameter: (this is the context where we give parameter only when
 * in func DEFINITION not in funct DECLARATION) We must have a name.
 * This function ensure that we give only parameterTypeDecl with well
 * formed Classic constructor todo?: do we accept other declaration
 * in ? so I must add them to the compound of the deffunc. I dont
 * have to handle typedef pb here cos C forbid to do VF f { ... }
 * with VF a typedef of func cos here we dont see the name of the
 * argument (in the typedef)
 *)
let (fixOldCDecl: fullType -> fullType) = fun ty ->
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, (b, iib))) ->

      (* stdC: If the prototype declaration declares a parameter for a
       * function that you are defining (it is part of a function
       * definition), then you must write a name within the declarator.
       * Otherwise, you can omit the name. *)
      (match params with
      | [{p_namei = None; p_type = ty2},_] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->
              ty
          | _ ->
              pr2_once ("SEMANTIC:parameter name omitted, but I continue");
              ty
          )

      | params ->
          (params +> List.iter (fun (param,_) ->
            match param with
            | {p_namei = None} ->
              (* if majuscule, then certainly macro-parameter *)
                pr2_once ("SEMANTIC:parameter name omitted, but I continue");
	    | _ -> ()
          ));
          ty
      )

        (* todo? can we declare prototype in the decl or structdef,
           ... => length <> but good kan meme *)
  | _ ->
      (* gcc say parse error but dont see why *)
      raise (Semantic ("seems this is not a function", fake_pi))


let fixFunc (typ, compound, old_style_opt) =
  let (cp,iicp) = compound in

  let (name, ty,   (st,iist),  attrs) = typ in

  let (qu, tybis) = ty in

  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params,abool)) ->
      let iifunc = Ast_c.get_ii_typeC_take_care tybis in

      let iistart = Ast_c.fakeInfo () in
      assert (qu =*= nullQualif);

      (match params with
      | [{p_namei= None; p_type = ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->  ()
          | _ ->
                (* failwith "internal errror: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei = Some s}, _) -> ()
	  | _ -> ()
                (* failwith "internal errror: fixOldCDecl not good" *)
          )
      );
      (* bugfix: cf tests_c/function_pointer4.c.
       * Apparemment en C on peut syntaxiquement ecrire ca:
       *
       *   void a(int)(int x);
       * mais apres gcc gueule au niveau semantique avec:
       *   xxx.c:1: error: 'a' declared as function returning a function
       * Je ne faisais pas cette verif. Sur du code comme
       *   void METH(foo)(int x) { ...} , le parser croit (a tort) que foo
       * est un typedef, et donc c'est parsé comme l'exemple precedent,
       * ce qui ensuite confuse l'unparser qui n'est pas habitué
       * a avoir dans le returnType un FunctionType et qui donc
       * pr_elem les ii dans le mauvais sens ce qui genere au final
       * une exception. Hence this fix to at least detect the error
       * at parsing time (not unparsing time).
       *)
      (match Ast_c.unwrap_typeC fullt with
      | FunctionType _ ->
          let s = Ast_c.str_of_name name in
          let iis = Ast_c.info_of_name name in
          pr2 (spf "WEIRD: %s declared as function returning a function." s);
          pr2 (spf "This is probably because of a macro. Extend standard.h");
          raise (Semantic (spf "error: %s " s, Ast_c.parse_info_of_info iis))
      | _ -> ()
      );

      (* it must be nullQualif,cos parser construct only this*)
      {f_name = name;
       f_type = (fullt, (params, abool));
       f_storage = st;
       f_body = cp;
       f_attr = attrs;
       f_old_c_style = old_style_opt;
      },
      (iifunc++iicp++[iistart]++iist)
  | _ ->
      raise
        (Semantic
            ("you are trying to do a function definition but you dont give " ^
             "any parameter", fake_pi))


(*-------------------------------------------------------------------------- *)
(* parse_typedef_fix2 *)
(*-------------------------------------------------------------------------- *)

let dt s () =
  if !Flag_parsing_c.debug_etdt then pr2 ("<" ^ s);
  LP.disable_typedef ()

let et s () =
  if !Flag_parsing_c.debug_etdt then pr2 (">" ^ s);
  LP.enable_typedef ()


let fix_add_params_ident x =
  let (s, ty, st, _attrs) = x in
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, bool)) ->

      (match params with
      | [{p_namei=None; p_type=ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void -> ()
          | _ ->
              (* failwith "internal errror: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei= Some name}, _) ->
              LP.add_ident (Ast_c.str_of_name s)
	  | _ ->
              ()
                (* failwith "internal errror: fixOldCDecl not good" *)
          )
      )
  | _ -> ()



(*-------------------------------------------------------------------------- *)
(* shortcuts *)
(*-------------------------------------------------------------------------- *)

let mk_e e ii = Ast_c.mk_e e ii

let mk_string_wrap (s,info) = (s, [info])

# 516 "parser_c.ml"
let yytransl_const = [|
    0|]

let yytransl_block = [|
  257 (* TUnknown *);
  258 (* TCommentSpace *);
  259 (* TCommentNewline *);
  260 (* TComment *);
  261 (* TInt *);
  262 (* TFloat *);
  263 (* TChar *);
  264 (* TString *);
  265 (* TQuote *);
  266 (* TPct *);
  267 (* TFormat *);
  268 (* TSubString *);
  269 (* TDecimal *);
  270 (* TIdent *);
  271 (* TKRParam *);
  272 (* Tconstructorname *);
  273 (* TypedefIdent *);
  274 (* TOPar *);
  275 (* TCPar *);
  276 (* TOBrace *);
  277 (* TCBrace *);
  278 (* TOCro *);
  279 (* TCCro *);
  280 (* TDot *);
  281 (* TComma *);
  282 (* TPtrOp *);
  283 (* TInc *);
  284 (* TDec *);
  285 (* TAssign *);
  286 (* TEq *);
  287 (* TWhy *);
  288 (* TTilde *);
  289 (* TBang *);
  290 (* TEllipsis *);
  291 (* TDotDot *);
  292 (* TPtVirg *);
  293 (* TOrLog *);
  294 (* TAndLog *);
  295 (* TOr *);
  296 (* TXor *);
  297 (* TAnd *);
  298 (* TEqEq *);
  299 (* TNotEq *);
  300 (* TInf *);
  301 (* TSup *);
  302 (* TInfEq *);
  303 (* TSupEq *);
  304 (* TShl *);
  305 (* TShr *);
  306 (* TPlus *);
  307 (* TMinus *);
  308 (* TMul *);
  309 (* TDiv *);
  310 (* TMod *);
  311 (* TMax *);
  312 (* TMin *);
  313 (* Tchar *);
  314 (* Tshort *);
  315 (* Tint *);
  316 (* Tdouble *);
  317 (* Tfloat *);
  318 (* Tlong *);
  319 (* Tunsigned *);
  320 (* Tsigned *);
  321 (* Tvoid *);
  322 (* Tsize_t *);
  323 (* Tssize_t *);
  324 (* Tptrdiff_t *);
  325 (* Tauto *);
  326 (* Tregister *);
  327 (* Textern *);
  328 (* Tstatic *);
  329 (* Ttypedef *);
  330 (* Tconst *);
  331 (* Tvolatile *);
  332 (* Tstruct *);
  333 (* Tunion *);
  334 (* Tenum *);
  335 (* Tdecimal *);
  336 (* Tbreak *);
  337 (* Telse *);
  338 (* Tswitch *);
  339 (* Tcase *);
  340 (* Tcontinue *);
  341 (* Tfor *);
  342 (* Tdo *);
  343 (* Tif *);
  344 (* Twhile *);
  345 (* Treturn *);
  346 (* Tgoto *);
  347 (* Tdefault *);
  348 (* Tsizeof *);
  349 (* Tnew *);
  350 (* Tdelete *);
  351 (* TOParCplusplusInit *);
  352 (* Tnamespace *);
  353 (* Trestrict *);
  354 (* Tasm *);
  355 (* Tattribute *);
  356 (* TattributeNoarg *);
  357 (* Tinline *);
  358 (* Ttypeof *);
  359 (* TDefine *);
  360 (* TDefParamVariadic *);
  361 (* TCppEscapedNewline *);
  362 (* TCppConcatOp *);
  363 (* TOParDefine *);
  364 (* TOBraceDefineInit *);
  365 (* TIdentDefine *);
  366 (* TDefEOL *);
  367 (* TInclude *);
  368 (* TIncludeStart *);
  369 (* TIncludeFilename *);
  370 (* TIfdef *);
  371 (* TIfdefelse *);
  372 (* TIfdefelif *);
  373 (* TEndif *);
  374 (* TIfdefBool *);
  375 (* TIfdefMisc *);
  376 (* TIfdefVersion *);
  377 (* TUndef *);
  378 (* TPragma *);
  379 (* TCppDirectiveOther *);
  380 (* TMacroAttr *);
  381 (* TMacroStmt *);
  382 (* TMacroIdentBuilder *);
  383 (* TMacroString *);
  384 (* TMacroDecl *);
  385 (* TMacroDeclConst *);
  386 (* TMacroIterator *);
  387 (* TMacroAttrStorage *);
  388 (* TCommentSkipTagStart *);
  389 (* TCommentSkipTagEnd *);
  390 (* TCParEOL *);
  391 (* TAction *);
  392 (* TCommentMisc *);
  393 (* TCommentCpp *);
    0 (* EOF *);
    0|]

let yylhs = "\255\255\
\001\000\006\000\006\000\006\000\008\000\008\000\009\000\010\000\
\010\000\012\000\012\000\012\000\011\000\011\000\011\000\013\000\
\013\000\004\000\004\000\015\000\015\000\015\000\016\000\016\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\017\000\017\000\020\000\
\020\000\020\000\020\000\020\000\020\000\020\000\020\000\020\000\
\025\000\025\000\025\000\025\000\025\000\025\000\024\000\024\000\
\024\000\024\000\024\000\024\000\024\000\023\000\023\000\023\000\
\023\000\023\000\023\000\023\000\023\000\023\000\023\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\031\000\031\000\035\000\035\000\036\000\037\000\
\037\000\037\000\040\000\040\000\040\000\039\000\041\000\044\000\
\021\000\022\000\003\000\045\000\045\000\045\000\045\000\045\000\
\045\000\045\000\045\000\045\000\046\000\046\000\046\000\046\000\
\052\000\052\000\054\000\054\000\054\000\034\000\056\000\056\000\
\058\000\058\000\058\000\059\000\059\000\059\000\059\000\059\000\
\047\000\047\000\048\000\048\000\048\000\049\000\049\000\049\000\
\049\000\049\000\049\000\049\000\049\000\050\000\050\000\050\000\
\050\000\050\000\050\000\032\000\032\000\051\000\051\000\064\000\
\066\000\066\000\066\000\066\000\066\000\067\000\068\000\068\000\
\068\000\068\000\068\000\068\000\068\000\068\000\068\000\068\000\
\068\000\068\000\068\000\068\000\068\000\068\000\068\000\068\000\
\068\000\027\000\071\000\071\000\071\000\072\000\072\000\073\000\
\074\000\074\000\075\000\075\000\076\000\076\000\076\000\076\000\
\078\000\078\000\077\000\077\000\077\000\077\000\077\000\077\000\
\080\000\081\000\085\000\085\000\085\000\086\000\086\000\086\000\
\086\000\086\000\086\000\086\000\086\000\086\000\084\000\084\000\
\088\000\088\000\088\000\088\000\038\000\038\000\090\000\090\000\
\090\000\091\000\091\000\093\000\093\000\093\000\093\000\094\000\
\079\000\079\000\005\000\005\000\095\000\095\000\096\000\096\000\
\096\000\096\000\096\000\096\000\096\000\096\000\101\000\101\000\
\101\000\101\000\101\000\101\000\101\000\101\000\103\000\103\000\
\103\000\103\000\103\000\102\000\102\000\053\000\089\000\105\000\
\105\000\105\000\099\000\107\000\106\000\106\000\106\000\106\000\
\108\000\108\000\100\000\100\000\100\000\029\000\029\000\112\000\
\112\000\112\000\112\000\112\000\114\000\114\000\114\000\110\000\
\110\000\115\000\115\000\115\000\120\000\120\000\120\000\120\000\
\121\000\121\000\121\000\121\000\121\000\122\000\122\000\124\000\
\124\000\124\000\125\000\125\000\125\000\069\000\116\000\128\000\
\126\000\127\000\118\000\118\000\070\000\070\000\070\000\133\000\
\133\000\134\000\060\000\136\000\136\000\137\000\137\000\135\000\
\135\000\135\000\138\000\139\000\139\000\141\000\141\000\140\000\
\140\000\140\000\061\000\061\000\061\000\061\000\061\000\061\000\
\143\000\143\000\143\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\146\000\146\000\146\000\146\000\146\000\062\000\062\000\062\000\
\062\000\062\000\062\000\062\000\147\000\147\000\147\000\007\000\
\007\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\055\000\057\000\130\000\132\000\109\000\111\000\117\000\
\119\000\082\000\083\000\033\000\033\000\063\000\063\000\065\000\
\065\000\026\000\026\000\098\000\098\000\144\000\144\000\129\000\
\129\000\123\000\123\000\131\000\131\000\097\000\097\000\087\000\
\087\000\042\000\042\000\043\000\043\000\014\000\014\000\014\000\
\113\000\113\000\148\000\148\000\104\000\104\000\092\000\030\000\
\030\000\145\000\145\000\019\000\019\000\000\000\000\000\000\000\
\000\000\000\000"

let yylen = "\002\000\
\002\000\000\000\002\000\006\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\003\000\002\000\004\000\001\000\
\003\000\001\000\003\000\001\000\003\000\003\000\001\000\005\000\
\001\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\001\000\004\000\001\000\
\002\000\002\000\002\000\002\000\004\000\002\000\005\000\002\000\
\004\000\003\000\004\000\003\000\001\000\004\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\004\000\004\000\
\003\000\003\000\003\000\002\000\002\000\005\000\007\000\001\000\
\001\000\001\000\001\000\003\000\001\000\001\000\003\000\001\000\
\002\000\003\000\000\000\002\000\002\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\002\000\005\000\006\000\001\000\003\000\004\000\006\000\003\000\
\001\000\001\000\002\000\003\000\002\000\003\000\000\000\001\000\
\001\000\001\000\002\000\001\000\001\000\001\000\001\000\001\000\
\001\000\002\000\005\000\007\000\005\000\005\000\007\000\006\000\
\007\000\006\000\007\000\005\000\004\000\002\000\001\000\001\000\
\001\000\002\000\003\000\001\000\001\000\002\000\001\000\002\000\
\001\000\004\000\007\000\001\000\000\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\006\000\004\000\001\000\004\000\
\004\000\001\000\001\000\001\000\001\000\003\000\001\000\001\000\
\001\000\001\000\002\000\001\000\001\000\002\000\002\000\003\000\
\001\000\001\000\001\000\003\000\003\000\004\000\003\000\004\000\
\001\000\001\000\001\000\001\000\002\000\003\000\002\000\003\000\
\003\000\004\000\002\000\003\000\003\000\004\000\001\000\003\000\
\001\000\002\000\002\000\001\000\001\000\002\000\001\000\002\000\
\002\000\001\000\002\000\001\000\001\000\002\000\002\000\001\000\
\001\000\002\000\001\000\002\000\001\000\002\000\002\000\003\000\
\005\000\006\000\007\000\007\000\008\000\009\000\001\000\001\000\
\001\000\001\000\002\000\002\000\002\000\002\000\001\000\001\000\
\001\000\001\000\001\000\001\000\002\000\001\000\001\000\001\000\
\003\000\004\000\001\000\001\000\001\000\002\000\002\000\002\000\
\004\000\005\000\001\000\004\000\002\000\001\000\003\000\001\000\
\004\000\002\000\003\000\003\000\002\000\003\000\005\000\001\000\
\000\000\005\000\004\000\002\000\001\000\001\000\002\000\002\000\
\001\000\001\000\005\000\001\000\001\000\003\000\002\000\001\000\
\002\000\003\000\001\000\002\000\002\000\001\000\001\000\001\000\
\001\000\001\000\001\000\000\000\005\000\006\000\002\000\001\000\
\003\000\001\000\001\000\001\000\002\000\001\000\002\000\002\000\
\003\000\003\000\001\000\002\000\001\000\003\000\004\000\001\000\
\002\000\002\000\002\000\004\000\007\000\003\000\004\000\001\000\
\003\000\002\000\001\000\001\000\001\000\001\000\001\000\002\000\
\002\000\001\000\005\000\006\000\004\000\005\000\001\000\000\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\005\000\004\000\002\000\001\000\
\001\000\005\000\001\000\001\000\001\000\001\000\005\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\002\000\001\000\002\000\001\000\
\003\000\001\000\003\000\001\000\003\000\001\000\002\000\001\000\
\002\000\001\000\003\000\001\000\003\000\001\000\003\000\001\000\
\003\000\001\000\002\000\000\000\002\000\000\000\001\000\003\000\
\001\000\002\000\001\000\002\000\001\000\002\000\001\000\001\000\
\000\000\001\000\000\000\001\000\000\000\002\000\002\000\002\000\
\002\000\002\000"

let yydefred = "\000\000\
\002\000\000\000\000\000\000\000\000\000\000\000\190\001\000\000\
\007\000\000\000\183\000\136\001\168\000\175\000\169\000\171\000\
\170\000\176\000\178\000\177\000\167\000\172\000\173\000\174\000\
\009\001\010\001\008\001\000\000\011\001\187\000\188\000\000\000\
\000\000\000\000\000\000\000\000\189\000\000\000\000\000\000\000\
\000\000\000\000\118\001\119\001\120\001\121\001\122\001\123\001\
\124\001\000\000\000\000\096\001\000\000\137\001\191\001\131\001\
\000\000\000\000\129\001\128\001\132\001\134\001\186\000\179\000\
\180\000\000\000\000\000\014\001\015\001\000\000\000\000\062\001\
\000\000\063\001\075\001\000\000\083\001\085\001\133\001\081\000\
\082\000\085\000\000\000\000\000\086\000\000\000\011\000\000\000\
\138\001\000\000\000\000\067\000\068\000\137\000\069\000\063\000\
\065\000\066\000\064\000\152\000\000\000\000\000\151\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\116\000\000\000\000\000\000\000\192\001\
\000\000\080\000\000\000\000\000\018\000\020\000\000\000\000\000\
\046\000\000\000\000\000\000\000\070\000\000\000\109\000\107\000\
\108\000\110\000\111\000\112\000\000\000\000\000\000\000\000\000\
\009\000\194\001\000\000\000\000\240\000\000\000\000\000\001\000\
\003\000\146\001\000\000\000\000\000\000\000\000\191\000\179\001\
\047\001\000\000\048\001\005\000\006\000\140\001\000\000\000\000\
\000\000\000\000\000\000\007\001\006\001\000\000\000\000\091\001\
\000\000\000\000\000\000\000\000\127\001\004\001\005\001\000\000\
\247\000\202\000\201\000\203\000\000\000\000\000\000\000\000\000\
\000\000\000\000\020\001\000\000\166\001\084\001\003\001\192\000\
\181\001\000\000\144\001\000\000\000\000\080\001\076\001\078\001\
\000\000\000\000\000\000\000\000\094\000\000\000\000\000\000\000\
\000\000\000\000\049\000\000\000\050\000\000\000\104\000\025\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\012\000\150\000\000\000\052\000\000\000\000\000\000\000\000\000\
\000\000\061\000\056\000\000\000\000\000\014\000\000\000\000\000\
\000\000\138\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\076\000\
\077\000\051\000\156\000\157\000\148\001\000\000\113\000\000\000\
\000\000\000\000\133\000\000\000\132\000\130\000\000\000\128\000\
\000\000\134\000\135\000\136\000\238\000\239\000\000\000\000\000\
\000\000\000\000\245\000\000\000\000\000\244\000\000\000\225\000\
\147\001\168\001\086\001\000\000\000\000\229\000\000\000\000\000\
\000\000\000\000\000\000\180\001\000\000\074\001\000\000\164\001\
\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\111\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\094\001\000\000\158\001\000\000\000\000\
\000\000\099\000\100\000\156\001\101\000\103\000\000\000\000\000\
\000\000\000\000\000\000\022\001\000\000\209\000\000\000\000\000\
\194\000\193\000\241\000\198\000\000\000\000\000\000\000\248\000\
\019\001\000\000\000\000\182\001\000\000\050\001\000\000\052\001\
\053\001\000\000\000\000\064\001\049\001\160\001\000\000\000\000\
\000\000\082\001\077\001\081\001\079\001\095\000\093\000\084\000\
\092\000\016\000\000\000\087\000\090\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\122\000\
\120\000\121\000\000\000\000\000\000\000\000\000\096\000\000\000\
\154\001\097\000\098\000\102\000\000\000\000\000\000\000\113\001\
\114\001\116\001\117\001\115\001\000\000\175\001\000\000\000\000\
\019\000\117\000\021\000\022\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\026\000\027\000\030\000\
\029\000\028\000\106\000\000\000\073\000\000\000\000\000\074\000\
\075\000\149\001\000\000\000\000\000\000\139\001\126\000\131\000\
\219\000\000\000\215\000\000\000\000\000\000\000\000\000\000\000\
\246\000\002\000\087\001\000\000\000\000\000\000\000\000\234\000\
\226\000\227\000\000\000\230\000\000\000\000\000\190\000\000\000\
\000\000\000\000\000\000\182\000\000\000\000\000\000\000\000\000\
\150\001\000\000\185\000\184\000\000\000\000\000\000\000\000\000\
\000\000\142\001\000\000\000\000\000\000\032\001\000\000\000\000\
\030\001\000\000\177\001\105\001\104\001\092\001\098\001\000\000\
\095\001\159\001\173\001\000\000\000\000\000\000\126\001\204\000\
\000\000\000\000\210\000\000\000\205\000\207\000\000\000\242\000\
\200\000\167\001\000\000\027\001\017\001\000\000\000\000\000\000\
\065\001\055\001\000\000\000\000\000\000\162\001\000\000\000\000\
\145\001\043\001\161\001\024\001\023\001\000\000\000\000\000\000\
\000\000\118\000\000\000\000\000\000\000\000\000\000\000\000\000\
\058\000\000\000\060\000\000\000\171\001\000\000\000\000\000\000\
\000\000\000\000\015\000\000\000\149\000\000\000\000\000\000\000\
\047\000\072\000\071\000\000\000\214\000\216\000\220\000\217\000\
\000\000\221\000\000\000\000\000\224\000\169\001\233\000\232\000\
\235\000\000\000\000\000\000\000\165\001\141\001\069\001\073\001\
\000\000\130\001\000\000\000\000\164\000\000\000\152\001\151\001\
\135\001\000\000\000\000\000\000\000\000\000\000\037\001\000\000\
\000\000\000\000\143\001\000\000\034\001\000\000\178\001\097\001\
\249\000\000\000\157\001\125\001\000\000\000\000\206\000\208\000\
\018\001\000\000\029\001\042\001\000\000\061\001\060\001\000\000\
\054\001\000\000\066\001\057\001\017\000\141\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\142\000\057\000\059\000\
\000\000\155\001\062\000\114\000\000\000\176\001\148\000\024\000\
\078\000\000\000\218\000\222\000\004\000\250\000\000\000\000\000\
\070\001\181\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\038\001\000\000\036\001\031\001\000\000\000\000\035\001\
\000\000\025\001\000\000\000\000\000\000\163\001\058\001\119\000\
\144\000\000\000\146\000\000\000\000\000\000\000\115\000\000\000\
\000\000\000\000\251\000\000\000\166\000\000\000\000\000\153\001\
\000\000\000\000\093\001\000\000\186\001\107\001\033\001\252\000\
\026\001\028\001\051\001\145\000\147\000\143\000\140\000\079\000\
\253\000\000\000\162\000\000\000\000\000\039\001\254\000\000\000\
\000\000\163\000"

let yydgoto = "\006\000\
\007\000\055\000\160\001\121\000\146\000\008\000\153\000\013\002\
\127\001\122\000\145\000\124\000\147\001\181\001\125\000\126\000\
\127\000\128\000\190\001\129\000\130\000\212\001\131\000\132\000\
\241\000\168\001\058\000\133\000\015\002\217\002\214\000\134\000\
\076\001\135\000\215\000\143\001\169\001\099\001\171\001\100\001\
\101\001\172\001\102\001\155\002\136\000\137\000\138\000\139\000\
\140\000\141\000\077\001\161\001\162\001\038\001\142\000\039\001\
\223\001\040\001\041\001\060\000\043\001\044\001\000\002\001\002\
\118\002\119\002\222\002\063\000\064\000\065\000\066\000\160\000\
\201\000\115\001\189\000\190\000\191\000\192\000\117\001\111\001\
\037\002\050\001\059\001\060\001\226\001\052\001\061\001\062\001\
\063\001\241\001\242\001\064\001\149\000\150\000\054\001\068\000\
\194\000\103\001\123\001\045\002\069\000\070\000\071\000\202\000\
\195\000\196\000\197\000\108\001\016\002\250\001\133\002\017\002\
\018\002\019\002\072\000\073\000\205\000\131\001\058\002\074\000\
\132\001\133\001\053\002\054\002\055\002\056\002\156\002\134\001\
\135\001\168\000\071\001\111\002\072\001\073\001\075\000\210\000\
\211\000\076\000\077\000\198\000\078\000\091\001\095\001\096\001\
\230\002\182\001\079\000\162\000"

let yysindex = "\098\003\
\000\000\242\008\049\016\146\019\157\005\000\000\000\000\061\009\
\000\000\038\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\143\255\000\000\000\000\000\000\233\254\
\233\254\113\000\100\255\078\255\000\000\109\255\238\026\118\255\
\051\255\112\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\129\255\247\255\000\000\167\255\000\000\000\000\000\000\
\072\255\238\026\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\238\026\212\016\000\000\000\000\238\026\233\255\000\000\
\155\000\000\000\000\000\033\024\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\048\000\000\000\028\000\000\000\226\017\
\000\000\146\019\146\019\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\129\000\146\019\000\000\134\000\
\049\016\166\000\168\000\146\019\230\000\196\000\146\019\047\016\
\146\019\039\255\220\000\000\000\221\000\000\000\238\000\000\000\
\096\255\000\000\000\000\218\000\000\000\000\000\056\001\045\006\
\000\000\157\005\153\001\146\019\000\000\016\255\000\000\000\000\
\000\000\000\000\000\000\000\000\224\000\075\015\028\000\248\000\
\000\000\000\000\157\005\157\005\000\000\244\000\007\001\000\000\
\000\000\000\000\244\024\019\001\174\000\037\001\000\000\000\000\
\000\000\233\254\000\000\000\000\000\000\000\000\039\001\020\255\
\146\019\050\001\016\255\000\000\000\000\227\016\213\012\000\000\
\228\000\024\255\004\012\004\012\000\000\000\000\000\000\241\255\
\000\000\000\000\000\000\000\000\103\255\036\255\229\255\223\000\
\241\255\193\255\000\000\018\255\000\000\000\000\000\000\000\000\
\000\000\233\255\000\000\054\001\177\024\000\000\000\000\000\000\
\212\016\105\024\214\255\107\001\000\000\117\001\048\000\114\001\
\003\000\110\001\000\000\157\005\000\000\146\019\000\000\000\000\
\059\001\145\016\053\001\146\019\146\019\248\000\028\000\146\019\
\000\000\000\000\201\015\000\000\157\005\135\001\140\001\108\012\
\138\001\000\000\000\000\016\255\147\001\000\000\022\000\252\009\
\146\019\000\000\201\015\146\019\146\019\146\019\146\019\146\019\
\146\019\146\019\146\019\146\019\146\019\146\019\146\019\146\019\
\146\019\146\019\146\019\146\019\146\019\146\019\146\019\146\019\
\146\019\146\019\149\001\100\010\146\019\020\255\020\255\000\000\
\000\000\000\000\000\000\000\000\000\000\016\255\000\000\000\000\
\146\019\134\001\000\000\152\001\000\000\000\000\163\001\000\000\
\075\015\000\000\000\000\000\000\000\000\000\000\038\001\018\018\
\114\000\125\025\000\000\189\000\040\001\000\000\193\001\000\000\
\000\000\000\000\000\000\154\001\190\001\000\000\050\008\175\026\
\004\012\199\001\201\001\000\000\020\255\000\000\197\001\000\000\
\200\001\079\000\000\000\027\255\204\001\208\001\210\001\049\016\
\055\255\022\000\178\017\000\000\000\000\096\255\000\000\075\015\
\000\000\102\001\125\001\000\000\204\010\000\000\126\001\124\001\
\103\001\000\000\000\000\000\000\000\000\000\000\080\000\033\255\
\218\001\070\255\000\000\000\000\229\255\000\000\066\018\244\024\
\000\000\000\000\000\000\000\000\223\000\000\000\128\009\000\000\
\000\000\004\012\114\018\000\000\177\024\000\000\222\001\000\000\
\000\000\249\020\221\001\000\000\000\000\000\000\177\024\103\255\
\241\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\141\001\000\000\000\000\149\001\136\000\146\019\
\201\015\162\018\162\018\230\001\143\000\154\000\248\000\000\000\
\000\000\000\000\149\001\052\011\156\011\115\001\000\000\200\000\
\000\000\000\000\000\000\000\000\146\019\234\001\016\255\000\000\
\000\000\000\000\000\000\000\000\216\000\000\000\049\016\251\000\
\000\000\000\000\000\000\000\000\248\000\214\001\245\022\067\023\
\155\003\017\004\034\003\182\003\182\003\029\002\029\002\029\002\
\029\002\037\002\037\002\070\002\070\002\000\000\000\000\000\000\
\000\000\000\000\000\000\210\018\000\000\253\000\017\000\000\000\
\000\000\000\000\062\001\201\015\201\015\000\000\000\000\000\000\
\000\000\246\001\000\000\244\001\189\000\154\001\002\019\244\024\
\000\000\000\000\000\000\057\025\013\000\233\254\097\255\000\000\
\000\000\000\000\099\001\000\000\255\000\004\012\000\000\197\001\
\020\255\249\001\146\019\000\000\146\019\180\022\135\000\237\001\
\000\000\010\002\000\000\000\000\194\001\016\255\031\002\006\001\
\028\000\000\000\146\019\160\000\015\002\000\000\026\002\082\017\
\000\000\202\000\000\000\000\000\000\000\000\000\000\000\020\001\
\000\000\000\000\000\000\120\255\004\012\019\002\000\000\000\000\
\016\255\039\002\000\000\036\002\000\000\000\000\154\001\000\000\
\000\000\000\000\044\001\000\000\000\000\082\017\221\001\004\012\
\000\000\000\000\233\254\241\255\037\000\000\000\027\002\146\019\
\000\000\000\000\000\000\000\000\000\000\049\002\045\002\049\016\
\040\002\000\000\050\019\098\019\146\019\049\016\049\016\045\002\
\000\000\085\001\000\000\089\001\000\000\121\026\004\012\084\000\
\058\002\076\002\000\000\022\000\000\000\049\016\146\019\130\017\
\000\000\000\000\000\000\201\015\000\000\000\000\000\000\000\000\
\073\002\000\000\154\001\252\022\000\000\000\000\000\000\000\000\
\000\000\250\255\106\001\249\001\000\000\000\000\000\000\000\000\
\086\002\000\000\088\002\093\002\000\000\083\002\000\000\000\000\
\000\000\094\002\092\002\016\255\083\013\125\255\000\000\178\017\
\178\017\096\002\000\000\026\002\000\000\178\017\000\000\000\000\
\000\000\114\018\000\000\000\000\099\002\016\255\000\000\000\000\
\000\000\026\002\000\000\000\000\120\001\000\000\000\000\106\019\
\000\000\146\019\000\000\000\000\000\000\000\000\201\015\049\016\
\123\001\049\016\127\001\130\001\032\002\000\000\000\000\000\000\
\138\001\000\000\000\000\000\000\084\002\000\000\000\000\000\000\
\000\000\104\002\000\000\000\000\000\000\000\000\114\018\131\001\
\000\000\000\000\146\019\108\002\135\000\146\019\058\002\100\002\
\023\002\000\000\146\019\000\000\000\000\113\002\118\002\000\000\
\105\002\000\000\121\002\118\002\106\002\000\000\000\000\000\000\
\000\000\049\016\000\000\049\016\114\002\049\016\000\000\178\017\
\123\002\130\002\000\000\114\018\000\000\195\002\141\002\000\000\
\170\001\084\002\000\000\192\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\180\002\000\000\199\002\114\002\000\000\000\000\146\019\
\200\002\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\034\022\000\000\000\000\000\000\231\000\
\235\000\000\000\000\000\000\000\000\000\000\000\134\020\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\220\020\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\252\020\000\000\000\000\000\000\017\021\063\020\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\092\004\209\002\000\000\027\026\000\000\045\027\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\184\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\141\004\000\000\000\000\
\000\000\000\000\066\026\000\000\000\000\000\000\212\006\111\002\
\000\000\000\000\227\005\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\201\002\134\002\223\003\
\000\000\000\000\129\009\157\009\000\000\004\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\228\019\000\000\000\000\000\000\000\000\115\003\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\115\002\000\000\
\000\000\000\000\177\001\041\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\069\023\000\000\109\021\103\000\
\000\000\000\000\000\000\047\000\000\000\000\000\000\000\000\000\
\000\000\149\020\000\000\234\003\203\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\209\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\190\002\002\005\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\150\005\000\000\
\010\006\000\000\000\000\000\000\000\000\000\000\178\001\000\000\
\000\000\000\000\000\000\000\000\000\000\193\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\103\005\000\000\110\022\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\028\255\000\000\000\000\000\000\000\000\000\000\193\025\000\000\
\014\000\000\000\000\000\025\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\208\002\000\000\045\255\000\000\
\177\001\000\000\000\000\000\000\000\000\000\000\217\002\000\000\
\191\000\000\000\000\000\211\002\000\000\000\000\000\000\000\000\
\000\000\178\001\000\000\000\000\209\013\129\002\079\014\000\000\
\205\014\131\002\000\000\000\000\000\000\000\000\000\000\132\002\
\041\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\143\023\000\000\199\021\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\084\001\217\023\000\000\000\000\
\000\000\177\001\000\000\000\000\203\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\219\002\074\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\252\002\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\207\002\000\000\
\000\000\000\000\000\000\000\000\000\000\181\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\212\002\000\000\243\001\033\002\
\013\001\048\008\220\001\227\007\017\008\218\004\111\007\150\007\
\192\007\034\007\072\007\250\001\251\006\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\042\255\064\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\030\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\193\025\061\255\021\255\000\000\
\000\000\000\000\000\000\000\000\000\000\177\001\000\000\217\002\
\227\002\000\000\000\000\000\000\000\000\000\000\171\255\230\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\105\026\000\000\000\000\000\000\000\000\000\000\217\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\041\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\001\
\000\000\000\000\087\255\000\000\000\000\000\000\051\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\087\006\
\000\000\000\000\000\000\000\000\000\000\000\000\177\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\068\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\032\000\000\000\000\000\063\255\000\000\000\000\
\000\000\000\000\000\000\000\000\115\002\000\000\000\000\000\000\
\227\002\000\000\000\000\217\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\217\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\127\008\000\000\000\000\000\000\
\135\006\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\229\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\171\255\000\000\142\002\000\000\
\000\000\000\000\000\000\000\000\000\000\143\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\233\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\149\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\150\002\000\000\000\000\000\000\
\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\002\000\008\000\187\255\203\254\249\003\228\255\
\255\255\026\000\253\255\185\255\000\000\179\002\145\000\175\000\
\188\000\199\006\000\000\050\000\130\000\193\254\000\000\000\000\
\185\001\035\255\023\000\000\000\049\254\000\000\049\003\251\255\
\131\003\209\255\000\000\000\000\000\000\105\004\000\000\045\254\
\000\000\101\002\169\002\156\255\000\000\000\000\102\255\000\000\
\000\000\000\000\091\255\023\255\005\000\000\000\000\000\000\000\
\000\000\037\255\089\255\117\255\041\000\019\000\000\000\028\002\
\000\000\096\001\104\001\000\000\000\000\000\000\158\008\194\003\
\156\003\240\002\131\255\129\001\076\255\000\000\000\000\000\000\
\067\002\001\000\235\254\238\254\159\255\230\254\000\000\040\003\
\007\000\000\000\000\000\240\255\000\000\128\255\000\000\000\000\
\000\000\123\255\003\254\193\253\036\001\000\000\000\000\000\000\
\000\000\000\000\242\002\000\000\159\254\052\254\243\253\136\254\
\000\000\089\002\000\000\000\000\161\003\241\002\064\002\000\000\
\000\000\000\000\000\000\216\001\000\000\059\002\215\001\236\002\
\000\000\205\003\052\003\014\002\133\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\254\001\000\000\000\000\
\000\000\041\002\000\000\000\000"

let yytablesize = 7315
let yytable = "\123\000\
\057\000\225\000\042\001\243\000\120\000\167\000\059\000\088\001\
\067\000\109\001\155\000\144\000\059\000\211\000\067\000\161\000\
\163\000\186\001\045\001\046\001\062\000\254\001\229\001\027\001\
\212\000\046\002\184\001\147\000\206\000\213\000\138\002\230\001\
\147\002\231\000\027\001\089\001\087\000\234\000\235\001\211\000\
\218\000\093\001\061\000\108\002\204\000\211\000\104\001\121\001\
\129\000\143\000\193\000\030\002\051\001\184\000\214\001\154\000\
\244\000\029\002\105\001\172\001\019\001\255\001\125\000\228\000\
\132\002\172\001\130\002\118\001\074\001\228\000\036\001\154\001\
\006\002\139\002\201\002\158\000\130\001\224\001\174\001\231\000\
\207\000\160\000\209\000\136\001\123\000\231\000\063\002\033\002\
\124\000\180\000\038\002\170\000\188\000\039\002\146\002\217\000\
\070\001\160\000\021\001\072\002\159\000\123\000\197\000\021\001\
\078\001\233\000\227\000\181\000\183\002\021\001\143\000\059\001\
\122\001\245\000\237\001\230\000\208\000\169\000\048\001\218\002\
\249\000\059\001\059\001\170\002\020\002\115\000\171\000\024\002\
\029\001\007\002\211\000\250\000\094\001\053\001\242\000\174\000\
\178\002\129\000\123\000\219\000\221\000\115\000\028\001\035\001\
\034\002\117\000\037\001\194\002\067\000\121\001\150\001\125\000\
\147\000\028\001\211\000\137\002\242\002\042\001\195\002\175\000\
\236\000\117\000\138\001\140\001\233\000\029\001\031\002\163\001\
\021\001\147\000\147\000\123\000\107\001\123\000\172\001\066\002\
\085\001\124\000\228\000\087\001\100\002\090\001\086\001\199\002\
\179\000\231\002\220\002\245\001\219\001\165\000\234\002\112\001\
\137\001\238\001\231\000\165\000\147\000\204\002\074\002\076\002\
\106\001\158\000\115\000\228\001\042\001\165\000\216\001\217\001\
\095\002\188\000\098\002\233\001\229\001\099\002\139\001\188\000\
\209\000\119\001\188\000\220\000\220\000\240\001\117\000\129\001\
\176\000\036\001\159\000\147\000\120\001\151\001\155\001\123\000\
\209\000\089\000\188\000\157\001\158\001\177\000\029\001\159\001\
\237\000\209\000\147\000\186\001\043\002\128\001\154\000\123\000\
\021\002\136\001\110\001\141\001\130\001\070\001\143\000\067\002\
\068\002\209\000\184\000\147\000\051\002\189\001\130\001\196\002\
\197\002\082\002\036\002\061\002\042\000\200\002\156\000\157\000\
\036\001\144\002\233\000\233\000\223\000\148\001\243\000\121\001\
\218\001\186\000\143\000\249\000\215\001\182\002\237\001\225\001\
\211\000\224\000\048\001\176\001\187\000\123\000\177\001\091\002\
\046\002\249\000\035\001\212\000\243\000\037\001\243\001\067\000\
\213\000\212\000\161\000\065\002\232\001\186\000\213\000\178\001\
\161\000\212\000\109\001\213\000\041\000\152\002\079\001\026\001\
\187\000\233\000\161\000\098\001\098\001\042\000\218\001\016\001\
\153\002\193\000\173\000\056\001\123\000\180\002\050\000\051\000\
\052\000\005\002\016\001\199\000\123\000\046\002\056\001\223\000\
\188\000\035\001\115\000\179\001\037\001\182\000\067\000\197\002\
\123\002\252\001\028\002\178\000\224\000\183\000\137\001\253\001\
\029\002\199\000\171\002\200\000\249\000\112\001\117\000\105\001\
\107\002\052\002\066\002\188\000\197\000\104\002\115\000\060\002\
\197\000\197\000\046\002\141\002\197\000\180\001\164\000\197\000\
\167\001\165\000\097\002\047\001\166\000\216\000\212\000\048\001\
\167\001\185\001\117\000\213\000\187\001\188\001\115\002\129\001\
\188\000\105\002\222\000\147\000\009\000\123\000\112\002\226\000\
\113\002\129\001\064\002\188\000\116\002\147\000\212\000\209\000\
\249\000\070\002\188\000\213\000\167\001\128\001\126\002\249\000\
\164\000\029\001\149\002\165\000\071\002\164\000\203\000\128\001\
\165\000\070\001\249\000\123\000\080\002\208\002\151\002\228\000\
\085\002\229\000\224\000\224\000\224\000\224\000\224\000\224\000\
\224\000\224\000\224\000\224\000\224\000\224\000\224\000\224\000\
\224\000\224\000\224\000\224\000\224\000\224\000\154\000\223\000\
\197\000\098\001\231\001\072\001\197\000\088\001\192\002\072\001\
\123\000\123\000\078\002\041\000\224\000\103\002\223\000\011\002\
\079\002\012\002\209\000\209\000\197\000\232\001\235\000\134\002\
\203\002\246\000\083\002\224\000\197\000\167\001\247\000\127\002\
\084\002\089\001\045\000\231\000\045\001\233\000\087\000\045\001\
\046\001\031\000\045\001\046\001\251\000\117\002\046\001\248\000\
\029\001\014\002\059\000\031\001\067\000\047\001\188\000\186\000\
\188\000\048\001\098\001\044\002\188\000\086\002\224\000\090\002\
\249\000\106\002\187\000\079\002\055\001\079\002\049\001\029\002\
\125\002\232\000\051\002\029\001\186\000\223\000\084\002\042\000\
\044\000\042\000\150\002\042\000\065\001\042\000\136\002\187\000\
\030\000\031\000\224\000\042\000\079\002\066\001\042\000\042\000\
\042\000\042\000\042\000\042\000\167\001\167\001\067\001\047\001\
\225\001\047\001\166\000\048\001\123\000\048\001\145\002\037\000\
\116\001\158\002\123\000\123\000\029\002\075\001\223\000\165\002\
\166\002\203\000\161\002\163\002\164\002\188\000\186\000\115\000\
\186\000\092\001\123\000\224\000\252\000\253\000\158\000\175\002\
\123\000\187\000\113\001\187\000\152\001\153\001\228\002\152\001\
\092\002\199\000\209\000\117\000\242\000\199\000\199\000\167\002\
\059\000\199\000\067\000\168\002\199\000\079\002\023\000\159\000\
\143\000\079\002\188\002\143\000\237\001\142\001\029\001\237\001\
\048\001\123\000\042\000\048\001\184\002\144\001\085\001\146\001\
\149\001\087\001\029\002\090\001\086\001\008\000\098\001\052\002\
\029\001\185\000\205\002\186\000\156\001\210\002\186\000\089\002\
\029\002\212\002\042\000\249\000\213\002\223\000\187\000\249\000\
\164\001\187\000\249\000\123\000\123\000\165\001\123\000\173\001\
\121\001\209\002\224\000\211\002\175\001\209\000\219\002\211\001\
\220\001\223\000\020\001\223\000\057\001\098\001\021\001\049\001\
\022\001\188\000\023\001\024\001\025\001\049\001\224\000\222\001\
\224\000\223\000\221\001\117\002\245\002\199\000\014\002\239\001\
\098\001\199\000\249\000\172\001\174\001\225\002\224\000\170\001\
\158\000\172\001\174\001\224\000\115\000\170\001\123\000\115\000\
\123\000\199\000\123\000\236\002\234\001\237\002\236\001\239\002\
\246\001\199\000\239\001\247\001\014\002\249\001\002\002\098\001\
\117\000\159\000\003\002\117\000\004\002\251\001\223\000\176\002\
\026\002\224\000\022\002\025\002\032\002\097\001\041\000\048\002\
\041\000\057\002\041\000\224\000\041\000\041\002\062\002\069\002\
\087\002\166\001\041\000\013\000\081\002\041\000\041\000\041\000\
\041\000\041\000\041\000\041\000\041\000\045\000\014\002\045\000\
\093\002\045\000\094\002\045\000\031\000\110\002\031\000\255\001\
\031\000\045\000\031\000\224\000\045\000\045\000\045\000\045\000\
\031\000\122\002\044\002\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\031\000\031\000\031\000\121\002\014\002\014\002\
\124\002\128\002\129\002\044\000\014\002\044\000\140\002\044\000\
\142\002\044\000\035\002\224\000\224\000\049\002\157\002\044\000\
\088\002\224\000\044\000\044\000\044\000\044\000\044\000\044\002\
\223\000\041\000\159\002\221\002\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\018\001\224\000\012\001\013\001\
\014\001\015\001\016\001\017\001\018\001\172\002\173\002\179\002\
\045\000\041\000\001\000\002\000\003\000\004\000\005\000\031\000\
\186\002\187\002\009\000\189\002\044\002\239\001\191\002\190\002\
\214\002\223\000\071\001\239\001\198\002\202\002\226\002\215\002\
\045\000\014\001\015\001\016\001\017\001\018\001\224\000\031\000\
\216\002\023\000\223\002\023\000\227\002\023\000\014\002\023\000\
\221\002\229\002\131\002\233\002\232\002\235\002\044\000\240\002\
\023\000\023\000\023\000\224\000\244\002\238\002\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\241\002\044\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\243\002\246\002\247\002\
\248\002\091\000\250\002\153\000\023\000\127\000\193\001\068\001\
\112\001\154\000\223\000\189\001\008\000\159\000\008\000\008\000\
\008\000\044\001\008\000\008\000\008\000\041\001\100\001\067\001\
\103\001\099\001\155\000\008\000\023\000\008\000\188\001\040\001\
\158\000\185\001\056\000\109\001\187\001\184\001\008\000\008\000\
\008\000\008\000\110\001\108\001\008\002\008\000\169\002\145\001\
\030\001\027\002\077\002\008\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\120\002\224\002\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\004\001\005\001\006\001\007\001\008\001\
\009\001\010\001\011\001\012\001\013\001\014\001\015\001\016\001\
\017\001\018\001\013\000\083\000\013\000\013\000\013\000\249\002\
\013\000\013\000\013\000\068\001\040\002\124\001\143\002\244\001\
\042\002\013\000\135\002\013\000\125\001\047\002\148\002\206\002\
\207\002\154\002\059\002\069\001\013\000\013\000\013\000\013\000\
\248\001\185\002\193\002\013\000\174\002\109\002\000\000\000\000\
\071\001\013\000\000\000\071\001\071\001\071\001\000\000\071\001\
\071\001\071\001\000\000\071\001\088\000\000\000\000\000\071\001\
\071\001\071\001\000\000\000\000\071\001\071\001\071\001\071\001\
\071\001\071\001\071\001\071\001\071\001\071\001\071\001\071\001\
\071\001\071\001\071\001\071\001\071\001\071\001\071\001\071\001\
\071\001\071\001\071\001\071\001\071\001\071\001\071\001\071\001\
\071\001\071\001\071\001\071\001\071\001\071\001\071\001\071\001\
\071\001\071\001\071\001\071\001\071\001\071\001\071\001\071\001\
\071\001\071\001\002\001\003\001\004\001\005\001\006\001\007\001\
\008\001\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\071\001\000\000\071\001\000\000\071\001\
\071\001\035\000\000\000\000\000\071\001\000\000\000\000\000\000\
\071\001\006\001\007\001\008\001\009\001\010\001\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\071\001\000\000\
\071\001\000\000\000\000\000\000\000\000\000\000\000\000\044\001\
\071\001\000\000\044\001\044\001\044\001\000\000\044\001\044\001\
\044\001\010\000\044\001\058\001\000\000\000\000\044\001\044\001\
\044\001\000\000\000\000\044\001\044\001\044\001\044\001\044\001\
\044\001\044\001\044\001\044\001\044\001\044\001\044\001\044\001\
\044\001\044\001\044\001\044\001\044\001\044\001\044\001\044\001\
\044\001\044\001\044\001\044\001\044\001\044\001\044\001\044\001\
\044\001\044\001\044\001\044\001\044\001\044\001\044\001\044\001\
\044\001\044\001\044\001\044\001\044\001\044\001\044\001\044\001\
\044\001\003\001\004\001\005\001\006\001\007\001\008\001\009\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\018\001\000\000\044\001\000\000\044\001\000\000\044\001\044\001\
\000\000\000\000\000\000\044\001\000\000\000\000\000\000\044\001\
\170\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\170\001\000\000\000\000\156\000\000\000\044\001\089\000\044\001\
\000\000\000\000\000\000\000\000\000\000\083\000\083\000\044\001\
\083\000\083\000\083\000\083\000\083\000\083\000\083\000\083\000\
\083\000\083\000\083\000\000\000\170\001\083\000\083\000\083\000\
\083\000\083\000\083\000\083\000\083\000\083\000\083\000\083\000\
\083\000\083\000\083\000\083\000\083\000\083\000\083\000\083\000\
\083\000\083\000\083\000\083\000\157\000\183\000\000\000\000\000\
\000\000\000\000\058\001\000\000\000\000\000\000\088\000\088\000\
\000\000\088\000\088\000\088\000\088\000\088\000\088\000\088\000\
\088\000\088\000\088\000\088\000\000\000\000\000\088\000\088\000\
\088\000\088\000\088\000\088\000\088\000\088\000\088\000\088\000\
\088\000\088\000\088\000\088\000\088\000\088\000\088\000\088\000\
\088\000\088\000\088\000\088\000\088\000\170\001\000\000\000\000\
\000\000\083\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\058\001\000\000\156\000\000\000\000\000\000\000\000\000\000\000\
\000\000\083\000\048\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\035\000\000\000\035\000\000\000\
\035\000\000\000\035\000\000\000\000\000\000\000\000\000\000\000\
\035\000\000\000\088\000\035\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\035\000\054\000\000\000\157\000\170\001\170\001\000\000\000\000\
\000\000\000\000\088\000\010\000\010\000\000\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\000\000\000\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\058\001\000\000\000\000\000\000\102\002\000\000\053\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\010\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\089\000\089\000\000\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\055\000\010\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\183\000\000\000\183\000\183\000\183\000\011\000\183\000\000\000\
\000\000\000\000\183\000\183\000\183\000\000\000\000\000\183\000\
\183\000\183\000\183\000\183\000\183\000\183\000\183\000\183\000\
\183\000\183\000\183\000\183\000\183\000\183\000\183\000\183\000\
\183\000\183\000\183\000\183\000\183\000\183\000\000\000\000\000\
\000\000\000\000\000\000\025\000\089\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\000\000\000\000\000\000\000\000\000\000\030\000\031\000\
\032\000\033\000\034\000\035\000\089\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\048\000\000\000\048\000\
\000\000\048\000\032\000\048\000\000\000\037\000\000\000\048\000\
\048\000\048\000\040\000\183\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\183\000\054\000\000\000\054\000\000\000\
\054\000\033\000\054\000\000\000\000\000\000\000\054\000\054\000\
\054\000\000\000\000\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\000\000\000\000\000\000\000\000\000\000\034\000\
\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\
\048\000\255\000\000\001\001\001\002\001\003\001\004\001\005\001\
\006\001\007\001\008\001\009\001\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\018\001\000\000\000\000\000\000\
\048\000\053\000\000\000\053\000\000\000\053\000\036\000\053\000\
\000\000\000\000\000\000\053\000\053\000\053\000\000\000\054\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\054\000\
\000\000\000\000\000\000\000\000\000\000\037\000\000\000\000\000\
\000\000\055\000\000\000\055\000\000\000\055\000\000\000\055\000\
\000\000\000\000\000\000\055\000\055\000\055\000\000\000\000\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\038\000\
\000\000\000\000\000\000\000\000\053\000\191\001\192\001\193\001\
\194\001\195\001\196\001\197\001\198\001\199\001\200\001\201\001\
\202\001\203\001\204\001\205\001\206\001\207\001\208\001\209\001\
\210\001\000\000\000\000\000\000\053\000\000\000\000\000\000\000\
\000\000\000\000\039\000\000\000\000\000\000\000\025\000\000\000\
\025\000\000\000\025\000\000\000\025\000\000\000\000\000\000\000\
\000\000\000\000\025\000\000\000\055\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\055\000\032\000\000\000\032\000\
\040\000\032\000\000\000\032\000\000\000\000\000\000\000\000\000\
\000\000\032\000\000\000\000\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\032\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\032\000\032\000\032\000\000\000\043\000\
\000\000\000\000\000\000\000\000\033\000\000\000\033\000\000\000\
\033\000\000\000\033\000\000\000\000\000\000\000\000\000\000\000\
\033\000\025\000\000\000\033\000\033\000\033\000\033\000\033\000\
\033\000\033\000\033\000\033\000\033\000\033\000\033\000\033\000\
\033\000\033\000\033\000\000\000\000\000\000\000\000\000\000\000\
\000\000\025\000\034\000\000\000\034\000\000\000\034\000\000\000\
\034\000\000\000\000\000\000\000\000\000\000\000\034\000\000\000\
\032\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\000\000\000\000\000\000\000\000\000\000\139\000\000\000\
\032\000\036\000\000\000\036\000\000\000\036\000\000\000\036\000\
\000\000\000\000\000\000\000\000\000\000\036\000\000\000\033\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\000\000\000\000\
\000\000\000\000\148\000\000\000\000\000\000\000\000\000\033\000\
\037\000\000\000\037\000\000\000\037\000\000\000\037\000\000\000\
\000\000\000\000\000\000\000\000\037\000\034\000\000\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\037\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\034\000\000\000\000\000\
\000\000\000\000\038\000\000\000\038\000\000\000\038\000\000\000\
\038\000\000\000\000\000\000\000\036\000\000\000\038\000\000\000\
\000\000\038\000\038\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\000\000\
\000\000\054\000\000\000\000\000\036\000\039\000\000\000\039\000\
\000\000\039\000\000\000\039\000\000\000\000\000\000\000\000\000\
\000\000\039\000\000\000\037\000\039\000\039\000\039\000\039\000\
\039\000\039\000\039\000\039\000\039\000\039\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\037\000\000\000\000\000\000\000\148\000\
\000\000\000\000\000\000\040\000\000\000\040\000\000\000\040\000\
\000\000\040\000\000\000\000\000\000\000\038\000\000\000\040\000\
\148\000\148\000\040\000\040\000\040\000\040\000\040\000\040\000\
\040\000\040\000\040\000\040\000\152\000\000\000\000\000\143\000\
\000\000\000\000\043\000\237\001\043\000\038\000\043\000\048\001\
\043\000\000\000\000\000\148\000\000\000\000\000\043\000\000\000\
\039\000\043\000\043\000\043\000\043\000\043\000\043\000\043\000\
\000\000\000\000\186\000\000\000\000\000\114\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\187\000\000\000\000\000\
\039\000\000\000\148\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\148\000\000\000\000\000\000\000\000\000\040\000\000\000\
\236\000\000\000\000\000\139\000\139\000\139\000\139\000\139\000\
\000\000\000\000\148\000\139\000\139\000\000\000\139\000\139\000\
\139\000\000\000\139\000\139\000\158\000\000\000\040\000\000\000\
\000\000\139\000\139\000\115\000\237\000\043\000\139\000\139\000\
\000\000\000\000\139\000\000\000\139\000\000\000\000\000\139\000\
\000\000\000\000\000\000\000\000\000\000\159\000\000\000\117\000\
\139\000\139\000\139\000\000\000\000\000\043\000\000\000\139\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\139\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\139\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\000\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\139\000\
\139\000\139\000\139\000\139\000\139\000\000\000\000\000\139\000\
\139\000\000\000\000\000\139\000\139\000\139\000\000\000\000\000\
\139\000\000\000\000\000\000\000\139\000\000\000\139\000\000\000\
\139\000\139\000\139\000\139\000\139\000\139\000\139\000\139\000\
\139\000\139\000\000\000\139\000\139\000\139\000\139\000\009\000\
\139\000\010\000\011\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\001\000\000\000\000\012\000\000\000\000\000\
\000\000\000\000\148\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\148\000\000\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\010\000\011\000\000\000\000\000\
\000\000\036\000\037\000\038\000\000\000\000\000\039\000\040\000\
\041\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\042\000\000\000\043\000\044\000\045\000\046\000\047\000\
\048\000\049\000\050\000\051\000\052\000\000\000\000\000\000\000\
\000\000\053\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\143\000\236\000\000\000\
\000\000\184\000\236\000\236\000\000\000\000\000\236\000\000\000\
\000\000\000\000\000\000\000\000\151\000\037\000\000\000\000\000\
\000\000\039\000\040\000\236\000\236\000\000\000\000\000\000\000\
\186\000\236\000\237\000\000\000\000\000\000\000\237\000\237\000\
\000\000\000\000\237\000\187\000\236\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\053\000\000\000\000\000\237\000\
\237\000\000\000\000\000\000\000\000\000\237\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\237\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\158\000\236\000\000\000\000\000\000\000\000\000\
\000\000\115\000\236\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\159\000\236\000\117\000\236\000\237\000\
\080\000\081\000\082\000\083\000\084\000\000\000\237\000\000\000\
\085\000\143\000\056\001\000\000\011\000\088\000\183\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\090\000\091\000\
\237\000\000\000\237\000\092\000\093\000\000\000\000\000\000\000\
\000\000\095\000\000\000\000\000\096\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\097\000\098\000\099\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\172\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\112\000\113\000\000\000\000\000\037\000\000\000\158\000\000\000\
\039\000\040\000\000\000\000\000\000\000\115\000\000\000\000\000\
\080\000\081\000\082\000\083\000\084\000\000\000\000\000\000\000\
\085\000\143\000\056\001\000\000\011\000\088\000\213\001\159\000\
\000\000\117\000\118\000\000\000\000\000\000\000\090\000\091\000\
\000\000\000\000\166\001\092\000\093\000\000\000\000\000\000\000\
\000\000\095\000\000\000\000\000\096\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\097\000\098\000\099\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\172\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\112\000\113\000\000\000\000\000\037\000\000\000\158\000\000\000\
\039\000\040\000\000\000\000\000\000\000\115\000\000\000\000\000\
\080\000\081\000\082\000\083\000\084\000\000\000\000\000\000\000\
\085\000\143\000\056\001\000\000\011\000\088\000\023\002\159\000\
\000\000\117\000\118\000\000\000\000\000\000\000\090\000\091\000\
\000\000\000\000\166\001\092\000\093\000\000\000\000\000\000\000\
\000\000\095\000\000\000\000\000\096\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\097\000\098\000\099\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\172\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\112\000\113\000\000\000\000\000\037\000\000\000\158\000\000\000\
\039\000\040\000\000\000\000\000\000\000\115\000\000\000\000\000\
\080\000\081\000\082\000\083\000\084\000\000\000\000\000\000\000\
\085\000\143\000\056\001\000\000\011\000\088\000\073\002\159\000\
\000\000\117\000\118\000\000\000\000\000\000\000\090\000\091\000\
\000\000\000\000\166\001\092\000\093\000\000\000\000\000\000\000\
\000\000\095\000\000\000\000\000\096\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\097\000\098\000\099\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\172\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\112\000\113\000\000\000\000\000\037\000\000\000\158\000\000\000\
\039\000\040\000\000\000\000\000\000\000\115\000\000\000\000\000\
\080\000\081\000\082\000\083\000\084\000\000\000\000\000\000\000\
\085\000\143\000\056\001\000\000\011\000\088\000\075\002\159\000\
\000\000\117\000\118\000\000\000\000\000\000\000\090\000\091\000\
\000\000\000\000\166\001\092\000\093\000\000\000\000\000\000\000\
\000\000\095\000\000\000\000\000\096\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\097\000\098\000\099\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\172\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\112\000\113\000\000\000\000\000\037\000\000\000\158\000\000\000\
\039\000\040\000\000\000\000\000\000\000\115\000\000\000\000\000\
\080\000\081\000\082\000\083\000\084\000\000\000\000\000\000\000\
\085\000\143\000\056\001\000\000\011\000\088\000\000\000\159\000\
\000\000\117\000\118\000\000\000\000\000\000\000\090\000\091\000\
\000\000\000\000\166\001\092\000\093\000\000\000\000\000\000\000\
\000\000\095\000\000\000\000\000\096\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\097\000\098\000\099\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\172\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\112\000\113\000\000\000\000\000\037\000\000\000\158\000\000\000\
\039\000\040\000\000\000\000\000\000\000\115\000\000\000\000\000\
\080\000\081\000\082\000\083\000\084\000\000\000\000\000\000\000\
\085\000\143\000\056\001\000\000\011\000\088\000\000\000\159\000\
\000\000\117\000\118\000\000\000\000\000\000\000\090\000\091\000\
\000\000\000\000\097\001\092\000\093\000\000\000\000\000\000\000\
\000\000\095\000\000\000\000\000\096\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\097\000\098\000\099\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\172\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\112\000\113\000\000\000\000\000\037\000\000\000\158\000\000\000\
\039\000\040\000\000\000\000\000\000\000\115\000\000\000\000\000\
\000\000\080\000\081\000\082\000\083\000\084\000\000\000\000\000\
\000\000\085\000\086\000\000\000\010\000\032\001\088\000\159\000\
\089\000\117\000\118\000\000\000\000\000\000\000\000\000\090\000\
\091\000\000\000\166\001\000\000\092\000\093\000\000\000\000\000\
\094\000\000\000\095\000\000\000\000\000\096\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\097\000\098\000\
\099\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\100\000\000\000\101\000\102\000\
\103\000\104\000\080\001\106\000\107\000\108\000\109\000\110\000\
\111\000\112\000\113\000\000\000\000\000\037\000\081\001\000\000\
\000\000\039\000\040\000\041\000\000\000\000\000\115\000\082\001\
\083\001\000\000\000\000\000\000\042\000\000\000\043\000\044\000\
\045\000\046\000\047\000\048\000\049\000\050\000\051\000\052\000\
\084\001\116\000\117\000\118\000\053\000\000\000\119\000\080\000\
\081\000\082\000\083\000\084\000\000\000\000\000\000\000\085\000\
\086\000\000\000\010\000\032\001\088\000\000\000\089\000\000\000\
\000\000\000\000\000\000\000\000\000\000\090\000\091\000\000\000\
\000\000\000\000\092\000\093\000\000\000\000\000\094\000\000\000\
\095\000\000\000\000\000\096\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\097\000\098\000\099\000\000\000\
\000\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\100\000\000\000\101\000\102\000\103\000\104\000\
\080\001\106\000\107\000\108\000\109\000\110\000\111\000\112\000\
\113\000\000\000\000\000\037\000\081\001\000\000\000\000\039\000\
\040\000\041\000\000\000\000\000\115\000\000\000\083\001\000\000\
\000\000\000\000\042\000\000\000\043\000\044\000\045\000\046\000\
\047\000\048\000\049\000\050\000\051\000\052\000\084\001\116\000\
\117\000\118\000\053\000\000\000\119\000\133\000\133\000\133\000\
\133\000\133\000\000\000\000\000\000\000\133\000\133\000\000\000\
\133\000\133\000\133\000\000\000\133\000\000\000\000\000\000\000\
\000\000\000\000\000\000\133\000\133\000\000\000\000\000\000\000\
\133\000\133\000\000\000\000\000\133\000\000\000\133\000\000\000\
\000\000\133\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\133\000\133\000\133\000\000\000\000\000\000\000\
\000\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\133\000\000\000\133\000\133\000\133\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\000\000\
\000\000\133\000\133\000\000\000\000\000\133\000\133\000\133\000\
\000\000\000\000\133\000\000\000\000\000\000\000\101\001\000\000\
\133\000\000\000\133\000\133\000\133\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\000\000\133\000\133\000\133\000\
\133\000\000\000\133\000\132\000\132\000\132\000\132\000\132\000\
\000\000\000\000\000\000\132\000\132\000\000\000\132\000\132\000\
\132\000\000\000\132\000\000\000\000\000\000\000\000\000\000\000\
\000\000\132\000\132\000\000\000\000\000\000\000\132\000\132\000\
\000\000\000\000\132\000\000\000\132\000\000\000\000\000\132\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\132\000\132\000\132\000\000\000\000\000\000\000\000\000\132\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\132\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\132\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\000\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\132\000\
\132\000\132\000\132\000\132\000\132\000\000\000\000\000\132\000\
\132\000\000\000\000\000\132\000\132\000\132\000\000\000\000\000\
\132\000\000\000\000\000\000\000\102\001\000\000\132\000\000\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\132\000\
\132\000\132\000\000\000\132\000\132\000\132\000\132\000\000\000\
\132\000\134\000\134\000\134\000\134\000\134\000\000\000\000\000\
\000\000\134\000\134\000\000\000\134\000\134\000\134\000\000\000\
\134\000\000\000\000\000\000\000\000\000\000\000\000\000\134\000\
\134\000\000\000\000\000\000\000\134\000\134\000\000\000\000\000\
\134\000\000\000\134\000\000\000\000\000\134\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\134\000\134\000\
\134\000\000\000\000\000\000\000\000\000\134\000\134\000\134\000\
\134\000\134\000\134\000\134\000\134\000\134\000\134\000\134\000\
\134\000\134\000\134\000\134\000\134\000\134\000\134\000\134\000\
\134\000\134\000\134\000\134\000\134\000\000\000\134\000\134\000\
\134\000\134\000\134\000\134\000\134\000\134\000\134\000\134\000\
\134\000\134\000\134\000\000\000\000\000\134\000\134\000\000\000\
\000\000\134\000\134\000\134\000\000\000\000\000\134\000\000\000\
\000\000\000\000\106\001\000\000\134\000\000\000\134\000\134\000\
\134\000\134\000\134\000\134\000\134\000\134\000\134\000\134\000\
\000\000\134\000\134\000\134\000\134\000\000\000\134\000\080\000\
\081\000\082\000\083\000\084\000\000\000\000\000\000\000\085\000\
\086\000\000\000\010\000\032\001\088\000\000\000\089\000\000\000\
\000\000\000\000\000\000\000\000\000\000\090\000\091\000\000\000\
\000\000\000\000\092\000\093\000\000\000\000\000\094\000\000\000\
\095\000\000\000\000\000\096\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\097\000\098\000\099\000\000\000\
\000\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\100\000\000\000\101\000\033\001\103\000\104\000\
\105\000\106\000\107\000\108\000\109\000\034\001\111\000\112\000\
\113\000\000\000\000\000\037\000\114\000\000\000\000\000\039\000\
\040\000\041\000\000\000\000\000\115\000\000\000\000\000\000\000\
\000\000\000\000\042\000\000\000\043\000\044\000\045\000\046\000\
\047\000\048\000\049\000\050\000\051\000\052\000\000\000\116\000\
\117\000\118\000\053\000\000\000\119\000\080\000\081\000\082\000\
\083\000\084\000\000\000\000\000\000\000\085\000\086\000\000\000\
\000\000\032\001\088\000\000\000\089\000\000\000\000\000\000\000\
\000\000\000\000\000\000\090\000\091\000\000\000\000\000\000\000\
\092\000\093\000\000\000\000\000\094\000\000\000\095\000\000\000\
\000\000\096\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\097\000\098\000\099\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\100\000\000\000\101\000\102\000\103\000\104\000\105\000\106\000\
\107\000\108\000\109\000\110\000\111\000\112\000\113\000\000\000\
\000\000\037\000\114\000\000\000\000\000\039\000\040\000\000\000\
\000\000\000\000\115\000\000\000\000\000\080\000\081\000\082\000\
\083\000\084\000\000\000\000\000\238\000\085\000\086\000\239\000\
\240\000\087\000\088\000\000\000\089\000\116\000\117\000\118\000\
\053\000\000\000\119\000\090\000\091\000\000\000\000\000\000\000\
\092\000\093\000\000\000\000\000\094\000\000\000\095\000\000\000\
\000\000\096\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\097\000\098\000\099\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\032\000\033\000\034\000\035\000\000\000\000\000\
\100\000\000\000\101\000\102\000\103\000\104\000\105\000\106\000\
\107\000\108\000\109\000\110\000\111\000\112\000\113\000\000\000\
\000\000\000\000\114\000\000\000\040\000\080\000\081\000\082\000\
\083\000\084\000\115\000\000\000\000\000\085\000\143\000\000\000\
\000\000\011\000\088\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\090\000\091\000\116\000\117\000\118\000\
\092\000\093\000\119\000\000\000\094\000\000\000\095\000\000\000\
\000\000\096\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\097\000\098\000\099\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\143\000\000\000\000\000\000\000\184\000\000\000\080\000\
\081\000\082\000\083\000\084\000\111\000\112\000\113\000\085\000\
\143\000\037\000\000\000\011\000\088\000\039\000\040\000\185\000\
\000\000\000\000\115\000\000\000\186\000\090\000\091\000\000\000\
\000\000\000\000\092\000\093\000\000\000\000\000\000\000\187\000\
\095\000\000\000\000\000\096\000\000\000\000\000\117\000\118\000\
\053\000\000\000\000\000\000\000\097\000\098\000\099\000\000\000\
\000\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\000\000\
\000\000\000\000\000\000\000\000\030\000\031\000\032\000\033\000\
\034\000\035\000\000\000\000\000\000\000\000\000\158\000\000\000\
\000\000\000\000\000\000\000\000\000\000\115\000\111\000\112\000\
\113\000\000\000\000\000\037\000\000\000\000\000\000\000\000\000\
\040\000\000\000\000\000\000\000\115\000\000\000\000\000\159\000\
\000\000\117\000\000\000\000\000\000\000\000\000\080\000\081\000\
\082\000\083\000\084\000\000\000\000\000\000\000\085\000\009\002\
\117\000\118\000\165\000\088\000\000\000\010\002\131\002\011\002\
\000\000\012\002\000\000\000\000\090\000\091\000\000\000\000\000\
\000\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\000\000\000\000\000\000\085\000\009\002\
\000\000\000\000\165\000\088\000\000\000\010\002\177\002\011\002\
\000\000\012\002\000\000\000\000\090\000\091\000\000\000\000\000\
\000\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\009\002\
\000\000\000\000\165\000\088\000\000\000\010\002\000\000\011\002\
\000\000\012\002\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\000\000\089\000\000\000\000\000\
\000\000\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\000\000\000\000\000\000\000\000\
\227\001\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\000\000\000\000\000\000\000\000\
\035\002\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\000\000\010\002\000\000\000\000\
\000\000\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\094\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\000\000\088\002\000\000\000\000\
\000\000\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\000\000\000\000\000\000\000\000\
\096\002\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\160\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\000\000\085\000\143\000\
\000\000\000\000\000\000\088\000\162\002\000\000\000\000\143\000\
\000\000\000\000\000\000\184\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\049\002\111\000\112\000\113\000\
\000\000\000\000\186\000\097\000\098\000\099\000\080\000\081\000\
\082\000\083\000\084\000\115\000\000\000\187\000\085\000\143\000\
\000\000\000\000\000\000\088\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\090\000\091\000\000\000\117\000\
\118\000\092\000\093\000\000\000\000\000\000\000\000\000\095\000\
\000\000\000\000\096\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\097\000\098\000\099\000\000\000\000\000\
\000\000\000\000\000\000\115\000\158\000\000\000\000\000\000\000\
\000\000\000\000\000\000\115\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\117\000\
\118\000\000\000\000\000\000\000\000\000\159\000\000\000\117\000\
\000\000\000\000\000\000\000\000\000\000\111\000\112\000\113\000\
\000\000\183\001\183\001\000\000\183\001\183\001\183\001\183\001\
\000\000\183\001\000\000\115\000\183\001\000\000\000\000\000\000\
\000\000\183\001\000\000\000\000\000\000\000\000\183\001\183\001\
\000\000\000\000\000\000\000\000\183\001\000\000\000\000\117\000\
\118\000\000\000\000\000\000\000\000\000\000\000\000\000\183\001\
\000\000\000\000\000\000\000\000\183\001\183\001\183\001\183\001\
\183\001\183\001\183\001\183\001\183\001\183\001\183\001\183\001\
\183\001\183\001\183\001\183\001\183\001\183\001\183\001\183\001\
\183\001\183\001\183\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\183\001\000\000\183\001\000\000\000\000\000\000\
\183\001\183\001\183\001\000\000\012\001\183\001\000\000\012\001\
\012\001\012\001\000\000\183\001\012\001\000\000\000\000\012\001\
\000\000\000\000\000\000\000\000\183\001\183\001\183\001\000\000\
\000\000\183\001\012\001\183\001\000\000\000\000\000\000\012\001\
\000\000\183\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\012\001\000\000\000\000\000\000\000\000\012\001\
\012\001\012\001\012\001\012\001\012\001\012\001\012\001\012\001\
\012\001\012\001\012\001\012\001\012\001\012\001\012\001\012\001\
\012\001\012\001\012\001\012\001\012\001\012\001\000\000\000\000\
\000\000\000\000\000\000\002\001\000\000\000\000\000\000\002\001\
\002\001\000\000\000\000\002\001\000\000\000\000\002\001\012\001\
\000\000\012\001\013\001\012\001\012\001\013\001\013\001\013\001\
\012\001\002\001\013\001\000\000\012\001\013\001\002\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\013\001\002\001\012\001\000\000\012\001\013\001\000\000\000\000\
\000\000\000\000\000\000\000\000\012\001\000\000\000\000\000\000\
\013\001\000\000\000\000\000\000\000\000\013\001\013\001\013\001\
\013\001\013\001\013\001\013\001\013\001\013\001\013\001\013\001\
\013\001\013\001\013\001\013\001\013\001\013\001\013\001\013\001\
\013\001\013\001\013\001\013\001\000\000\000\000\000\000\000\000\
\002\001\000\001\000\000\000\000\000\000\000\001\000\001\002\001\
\000\000\000\001\000\000\002\001\000\001\013\001\000\000\013\001\
\000\000\013\001\013\001\000\000\000\000\000\000\013\001\000\001\
\000\000\002\001\013\001\002\001\000\001\000\000\143\000\000\000\
\000\000\001\001\184\000\002\001\000\000\001\001\001\001\000\001\
\013\001\001\001\013\001\000\000\001\001\000\000\000\000\000\000\
\000\000\000\000\013\001\049\002\050\002\000\000\255\000\001\001\
\000\000\186\000\255\000\255\000\001\001\000\000\255\000\000\000\
\000\000\255\000\000\000\000\000\187\000\000\000\000\000\001\001\
\000\000\000\000\000\000\000\000\255\000\000\000\000\000\000\000\
\000\000\255\000\000\000\000\000\000\000\000\000\000\001\000\000\
\000\000\000\000\000\000\000\000\255\000\000\001\000\000\000\000\
\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\
\000\000\000\001\000\000\158\000\000\000\000\000\001\001\000\000\
\000\000\000\001\115\000\000\000\000\000\001\001\000\000\000\000\
\000\000\001\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\255\000\159\000\000\000\117\000\001\001\
\000\000\001\001\255\000\000\000\000\000\196\000\255\000\196\000\
\196\000\001\001\000\000\000\000\000\000\196\000\000\000\000\000\
\000\000\000\000\196\000\000\000\255\000\000\000\255\000\196\000\
\196\000\000\000\000\000\000\000\000\000\000\000\255\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\196\000\196\000\196\000\
\196\000\196\000\196\000\196\000\196\000\196\000\196\000\196\000\
\196\000\196\000\196\000\196\000\196\000\196\000\196\000\196\000\
\196\000\196\000\196\000\196\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\196\000\000\000\196\000\196\000\196\000\
\000\000\196\000\196\000\196\000\000\000\000\000\000\000\195\000\
\000\000\195\000\195\000\000\000\196\000\000\000\000\000\195\000\
\000\000\000\000\000\000\000\000\195\000\196\000\196\000\196\000\
\196\000\195\000\195\000\000\000\196\000\000\000\000\000\000\000\
\000\000\000\000\196\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\195\000\
\195\000\195\000\195\000\195\000\195\000\195\000\195\000\195\000\
\195\000\195\000\195\000\195\000\195\000\195\000\195\000\195\000\
\195\000\195\000\195\000\195\000\195\000\195\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\195\000\000\000\195\000\
\195\000\195\000\000\000\195\000\195\000\195\000\000\000\007\001\
\000\000\000\000\007\001\007\001\000\000\000\000\195\000\007\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\195\000\
\195\000\195\000\195\000\000\000\000\000\007\001\195\000\000\000\
\000\000\000\000\007\001\000\000\195\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\007\001\000\000\000\000\
\000\000\000\000\007\001\007\001\007\001\007\001\007\001\007\001\
\007\001\007\001\007\001\007\001\007\001\007\001\007\001\007\001\
\007\001\007\001\007\001\007\001\007\001\007\001\007\001\007\001\
\007\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\183\000\000\000\000\000\183\000\183\000\
\000\000\000\000\007\001\183\000\007\001\000\000\007\001\007\001\
\000\000\000\000\000\000\007\001\000\000\000\000\000\000\007\001\
\011\000\183\000\000\000\000\000\000\000\000\000\183\000\000\000\
\000\000\000\000\000\000\000\000\000\000\007\001\000\000\007\001\
\000\000\183\000\000\000\000\000\007\001\000\000\183\000\183\000\
\183\000\183\000\183\000\183\000\183\000\183\000\183\000\183\000\
\183\000\183\000\183\000\183\000\183\000\183\000\183\000\183\000\
\183\000\183\000\183\000\183\000\183\000\000\000\000\000\000\000\
\000\000\000\000\000\000\010\000\011\000\000\000\000\000\000\000\
\114\002\000\000\000\000\000\000\000\000\000\000\183\000\000\000\
\183\000\000\000\183\000\183\000\000\000\000\000\000\000\183\000\
\000\000\000\000\000\000\183\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\183\000\000\000\183\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\010\000\011\000\000\000\000\000\000\000\
\181\002\000\000\000\000\151\000\037\000\000\000\000\000\000\000\
\039\000\040\000\000\001\001\001\002\001\003\001\004\001\005\001\
\006\001\007\001\008\001\009\001\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\018\001\000\000\000\000\000\000\
\000\000\000\000\000\000\053\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\088\001\000\000\000\000\
\088\001\000\000\000\000\151\000\037\000\021\001\000\000\000\000\
\039\000\040\000\021\001\000\000\000\000\000\000\000\000\000\000\
\021\001\001\001\002\001\003\001\004\001\005\001\006\001\007\001\
\008\001\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\053\000\000\000\088\001\088\001\088\001\
\088\001\088\001\088\001\088\001\088\001\088\001\088\001\088\001\
\088\001\088\001\088\001\088\001\088\001\088\001\088\001\088\001\
\088\001\088\001\088\001\088\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\090\001\
\000\000\000\000\090\001\021\001\000\000\088\001\000\000\024\001\
\000\000\088\001\088\001\088\001\024\001\000\000\000\000\000\000\
\000\000\000\000\024\001\000\000\088\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\088\001\088\001\088\001\
\000\000\000\000\000\000\000\000\088\001\000\000\000\000\090\001\
\090\001\090\001\090\001\090\001\090\001\090\001\090\001\090\001\
\090\001\090\001\090\001\090\001\090\001\090\001\090\001\090\001\
\090\001\090\001\090\001\090\001\090\001\090\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\089\001\000\000\000\000\089\001\024\001\000\000\090\001\
\000\000\023\001\000\000\090\001\090\001\090\001\023\001\000\000\
\000\000\000\000\000\000\000\000\023\001\000\000\090\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\090\001\
\090\001\090\001\000\000\000\000\000\000\000\000\090\001\000\000\
\000\000\089\001\089\001\089\001\089\001\089\001\089\001\089\001\
\089\001\089\001\089\001\089\001\089\001\089\001\089\001\089\001\
\089\001\089\001\089\001\089\001\089\001\089\001\089\001\089\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\011\000\000\000\000\000\089\000\000\000\000\000\023\001\
\000\000\089\001\000\000\000\000\000\000\089\001\089\001\089\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\089\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\089\001\089\001\089\001\000\000\000\000\000\000\000\000\
\089\001\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\011\000\000\000\000\000\089\000\000\000\000\000\000\000\
\000\000\037\000\000\000\000\000\000\000\039\000\040\000\041\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\042\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\050\000\051\000\052\000\000\000\000\000\000\000\000\000\
\053\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\009\000\000\000\
\000\000\011\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\037\000\000\000\000\000\000\000\039\000\040\000\000\000\
\000\000\000\000\000\000\000\000\126\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\053\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\000\000\000\000\000\000\
\000\000\000\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\000\000\056\001\000\000\011\000\000\000\057\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\037\000\000\000\000\000\000\000\000\000\040\000\041\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\042\000\000\000\043\000\044\000\045\000\046\000\047\000\048\000\
\049\000\050\000\051\000\052\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\172\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\056\001\
\000\000\011\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\037\000\000\000\158\000\000\000\
\039\000\040\000\101\002\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\159\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\172\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\000\000\000\000\056\001\000\000\011\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\037\000\000\000\158\000\000\000\039\000\040\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\159\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\172\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\000\000\000\000\146\001\
\000\000\146\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\037\000\000\000\158\000\
\000\000\039\000\040\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\159\000\146\001\146\001\146\001\146\001\146\001\146\001\146\001\
\146\001\146\001\146\001\146\001\146\001\146\001\146\001\146\001\
\146\001\146\001\146\001\146\001\146\001\146\001\146\001\146\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\146\001\000\000\146\001\000\000\146\001\146\001\000\000\
\000\000\000\000\000\000\000\000\008\000\000\000\000\000\000\000\
\008\000\000\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\000\000\000\000\146\001\010\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\009\000\000\000\000\000\000\000\009\000\
\000\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\000\000\000\000\000\000\012\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\008\000\000\000\000\000\008\000\008\000\000\000\
\008\000\008\000\008\000\008\000\008\000\000\000\238\000\008\000\
\008\000\239\000\000\000\005\000\000\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\009\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\056\001\000\000\011\000\
\000\000\000\000\000\000\000\000\032\000\033\000\034\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\040\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\172\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\011\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\037\000\
\000\000\000\000\000\000\039\000\040\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\172\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\105\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\037\000\000\000\
\000\000\000\000\039\000\040\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\105\000\105\000\105\000\
\105\000\105\000\105\000\105\000\105\000\105\000\105\000\105\000\
\105\000\000\000\000\000\000\000\000\000\000\000\105\000\105\000\
\105\000\105\000\105\000\105\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\105\000\000\000\000\000\
\000\000\000\000\105\000"

let yycheck = "\003\000\
\002\000\102\000\142\000\000\000\003\000\034\000\002\000\175\000\
\002\000\190\000\010\000\004\000\008\000\000\000\008\000\032\000\
\033\000\251\000\147\000\148\000\002\000\075\001\049\001\008\001\
\000\000\123\001\248\000\005\000\076\000\000\000\028\002\050\001\
\046\002\014\001\008\001\175\000\017\001\109\000\060\001\019\001\
\088\000\018\001\002\000\248\001\073\000\025\001\180\000\030\001\
\021\001\014\001\067\000\019\001\150\000\018\001\020\001\018\001\
\018\001\025\001\184\000\019\001\130\000\035\001\021\001\019\001\
\016\002\025\001\015\002\193\000\169\000\025\001\142\000\226\000\
\018\001\029\002\138\002\099\001\205\000\041\001\244\000\019\001\
\076\000\019\001\076\000\209\000\021\001\025\001\150\001\018\001\
\021\001\018\001\112\001\014\001\067\000\112\001\046\002\088\000\
\168\000\035\001\025\001\163\001\124\001\105\000\000\000\030\001\
\174\000\109\000\105\000\036\001\106\002\036\001\014\001\025\001\
\095\001\075\001\018\001\108\000\076\000\018\001\022\001\183\002\
\025\001\035\001\036\001\079\002\088\001\106\001\018\001\093\001\
\134\000\075\001\110\001\036\001\109\001\150\000\112\000\018\001\
\088\002\110\001\142\000\090\000\091\000\106\001\127\001\142\000\
\075\001\126\001\142\000\023\001\142\000\030\001\220\000\110\001\
\130\000\127\001\134\001\036\001\220\002\041\001\034\001\109\001\
\111\000\126\001\210\000\211\000\168\000\171\000\134\001\237\000\
\095\001\147\000\148\000\175\000\189\000\110\001\134\001\153\001\
\175\000\110\001\134\001\175\000\234\001\175\000\175\000\132\002\
\018\001\199\002\184\002\065\001\033\001\019\001\204\002\191\000\
\209\000\063\001\134\001\025\001\174\000\146\002\164\001\165\001\
\098\001\099\001\106\001\048\001\088\001\035\001\022\001\023\001\
\230\001\184\000\232\001\053\001\239\001\232\001\210\000\190\000\
\210\000\025\001\193\000\090\000\091\000\063\001\126\001\205\000\
\113\001\041\001\124\001\205\000\036\001\222\000\226\000\235\000\
\226\000\020\001\209\000\228\000\229\000\109\001\244\000\232\000\
\111\000\235\000\220\000\221\001\122\001\205\000\018\001\251\000\
\090\001\119\001\022\001\211\000\125\001\069\001\014\001\154\001\
\155\001\251\000\018\001\237\000\130\001\254\000\135\001\128\002\
\129\002\175\001\111\001\137\001\000\000\134\002\128\001\129\001\
\088\001\039\002\022\001\023\001\102\000\019\001\019\001\030\001\
\030\001\041\001\014\001\025\001\021\001\036\001\018\001\019\001\
\019\001\102\000\022\001\014\001\052\001\041\001\017\001\023\001\
\138\002\025\001\041\001\019\001\113\000\041\001\063\001\041\001\
\019\001\025\001\019\001\152\001\052\001\041\001\025\001\034\001\
\025\001\010\001\239\001\012\001\103\001\025\001\174\000\132\000\
\052\001\069\001\035\001\179\000\180\000\112\001\076\001\025\001\
\036\001\090\001\039\000\025\001\080\001\099\002\121\001\122\001\
\123\001\080\001\036\001\000\000\088\001\183\002\036\001\169\000\
\063\001\088\001\106\001\070\001\088\001\058\000\088\001\216\002\
\006\002\019\001\019\001\109\001\169\000\066\000\119\001\025\001\
\025\001\070\000\023\001\131\001\025\001\109\001\126\001\237\001\
\246\001\130\001\092\002\090\001\014\001\243\001\106\001\136\001\
\018\001\019\001\220\002\033\002\022\001\104\001\014\001\025\001\
\240\000\017\001\231\001\018\001\020\001\106\001\110\001\022\001\
\248\000\249\000\126\001\110\001\252\000\253\000\008\001\125\001\
\119\001\243\001\018\001\125\001\014\001\153\001\251\001\018\001\
\253\001\135\001\019\001\130\001\022\001\135\001\134\001\153\001\
\025\001\019\001\137\001\134\001\020\001\125\001\011\002\025\001\
\014\001\175\001\048\002\017\001\019\001\014\001\020\001\135\001\
\017\001\249\001\025\001\183\001\173\001\159\002\052\002\018\001\
\183\001\018\001\255\000\000\001\001\001\002\001\003\001\004\001\
\005\001\006\001\007\001\008\001\009\001\010\001\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\018\001\033\001\
\106\001\065\001\022\001\021\001\110\001\125\002\124\002\025\001\
\220\001\221\001\019\001\000\000\033\001\238\001\048\001\022\001\
\025\001\024\001\220\001\221\001\126\001\229\001\035\001\030\001\
\142\002\014\001\019\001\048\001\134\001\093\001\018\001\012\002\
\025\001\125\002\000\000\014\001\014\001\249\001\017\001\017\001\
\014\001\000\000\020\001\017\001\035\001\255\001\020\001\018\001\
\006\002\083\001\254\001\036\001\254\001\018\001\237\001\041\001\
\239\001\022\001\122\001\123\001\243\001\019\001\083\001\019\001\
\025\001\019\001\052\001\025\001\014\001\025\001\150\000\025\001\
\019\001\052\001\152\002\033\002\041\001\111\001\025\001\019\001\
\000\000\021\001\051\002\023\001\018\001\025\001\019\001\052\001\
\074\001\075\001\111\001\031\001\025\001\128\001\034\001\035\001\
\036\001\037\001\038\001\039\001\164\001\165\001\018\001\018\001\
\019\001\018\001\020\001\022\001\064\002\022\001\019\001\097\001\
\192\000\064\002\070\002\071\002\025\001\020\001\152\001\070\002\
\071\002\020\001\067\002\068\002\069\002\052\002\041\001\106\001\
\041\001\110\001\086\002\152\001\029\001\030\001\099\001\086\002\
\092\002\052\001\124\001\052\001\034\001\035\001\195\002\034\001\
\035\001\014\001\092\002\126\001\078\002\018\001\019\001\019\001\
\100\002\022\001\100\002\019\001\025\001\025\001\000\000\124\001\
\014\001\025\001\116\002\014\001\018\001\011\001\124\002\018\001\
\022\001\125\002\110\001\022\001\019\001\009\001\125\002\014\001\
\019\001\125\002\025\001\125\002\125\002\000\000\246\001\152\002\
\142\002\036\001\019\001\041\001\088\001\019\001\041\001\212\001\
\025\001\019\001\134\001\025\001\019\001\231\001\052\001\025\001\
\018\001\052\001\025\001\159\002\160\002\018\001\162\002\022\001\
\030\001\160\002\231\001\162\002\018\001\159\002\036\001\019\001\
\035\001\251\001\018\001\253\001\019\001\029\002\022\001\047\001\
\024\001\152\002\026\001\027\001\028\001\053\001\251\001\021\001\
\253\001\011\002\035\001\189\002\019\001\106\001\016\002\063\001\
\048\002\110\001\025\001\019\001\019\001\190\002\011\002\019\001\
\099\001\025\001\025\001\016\002\106\001\025\001\210\002\106\001\
\212\002\126\001\214\002\210\002\020\001\212\002\025\001\214\002\
\018\001\134\001\090\001\019\001\046\002\025\001\019\001\079\002\
\126\001\124\001\019\001\126\001\019\001\030\001\056\002\087\002\
\109\001\046\002\110\001\110\001\019\001\135\001\019\001\018\001\
\021\001\021\001\023\001\056\002\025\001\117\001\106\001\018\001\
\035\001\135\001\031\001\000\000\019\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\019\001\088\002\021\001\
\019\001\023\001\023\001\025\001\019\001\021\001\021\001\035\001\
\023\001\031\001\025\001\088\002\034\001\035\001\036\001\037\001\
\031\001\088\001\138\002\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\036\001\128\002\129\002\
\018\001\035\001\025\001\019\001\134\002\021\001\036\001\023\001\
\018\001\025\001\023\001\128\002\129\002\035\001\014\001\031\001\
\020\001\134\002\034\001\035\001\036\001\037\001\038\001\183\002\
\154\002\110\001\035\001\187\002\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\154\002\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\036\001\019\001\023\001\
\110\001\134\001\001\000\002\000\003\000\004\000\005\000\110\001\
\019\001\018\001\014\001\025\001\220\002\237\001\019\001\018\001\
\081\001\195\002\000\000\243\001\021\001\019\001\019\001\036\001\
\134\001\052\001\053\001\054\001\055\001\056\001\195\002\134\001\
\025\001\019\001\023\001\021\001\110\001\023\001\216\002\025\001\
\248\002\025\001\021\001\019\001\036\001\036\001\110\001\021\001\
\034\001\035\001\036\001\216\002\008\001\036\001\017\001\018\001\
\019\001\020\001\021\001\022\001\023\001\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\036\001\134\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\019\001\023\001\036\001\
\018\001\009\001\019\001\036\001\110\001\021\001\000\000\021\001\
\110\001\036\001\019\001\035\001\095\001\019\001\097\001\098\001\
\099\001\000\000\101\001\102\001\103\001\021\001\110\001\021\001\
\110\001\110\001\036\001\110\001\134\001\112\001\035\001\021\001\
\019\001\021\001\002\000\110\001\110\001\021\001\121\001\122\001\
\123\001\124\001\110\001\110\001\082\001\128\001\078\002\215\000\
\134\000\097\001\166\001\134\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\000\002\189\002\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\095\001\000\000\097\001\098\001\099\001\248\002\
\101\001\102\001\103\001\162\000\117\001\202\000\036\002\064\001\
\119\001\110\001\018\002\112\001\204\000\125\001\047\002\152\002\
\154\002\055\002\135\001\167\000\121\001\122\001\123\001\124\001\
\069\001\108\002\125\002\128\001\084\002\249\001\255\255\255\255\
\014\001\134\001\255\255\017\001\018\001\019\001\255\255\021\001\
\022\001\023\001\255\255\025\001\000\000\255\255\255\255\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\097\001\255\255\099\001\255\255\101\001\
\102\001\000\000\255\255\255\255\106\001\255\255\255\255\255\255\
\110\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\124\001\255\255\
\126\001\255\255\255\255\255\255\255\255\255\255\255\255\014\001\
\134\001\255\255\017\001\018\001\019\001\255\255\021\001\022\001\
\023\001\000\000\025\001\155\000\255\255\255\255\029\001\030\001\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\097\001\255\255\099\001\255\255\101\001\102\001\
\255\255\255\255\255\255\106\001\255\255\255\255\255\255\110\001\
\240\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\248\000\255\255\255\255\008\001\255\255\124\001\000\000\126\001\
\255\255\255\255\255\255\255\255\255\255\018\001\019\001\134\001\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\255\255\020\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\008\001\000\000\255\255\255\255\
\255\255\255\255\050\001\255\255\255\255\255\255\018\001\019\001\
\255\255\021\001\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\093\001\255\255\255\255\
\255\255\110\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\112\001\255\255\127\001\255\255\255\255\255\255\255\255\255\255\
\255\255\134\001\000\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\019\001\255\255\021\001\255\255\
\023\001\255\255\025\001\255\255\255\255\255\255\255\255\255\255\
\031\001\255\255\110\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\000\000\255\255\127\001\164\001\165\001\255\255\255\255\
\255\255\255\255\134\001\018\001\019\001\255\255\021\001\022\001\
\023\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\110\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\232\001\255\255\255\255\255\255\236\001\255\255\000\000\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\134\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\110\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\018\001\019\001\255\255\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\000\000\134\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\019\001\255\255\021\001\022\001\023\001\017\001\025\001\255\255\
\255\255\255\255\029\001\030\001\031\001\255\255\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\255\255\255\255\
\255\255\255\255\255\255\000\000\110\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\255\255\255\255\255\255\255\255\255\255\074\001\075\001\
\076\001\077\001\078\001\079\001\134\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\019\001\255\255\021\001\
\255\255\023\001\000\000\025\001\255\255\097\001\255\255\029\001\
\030\001\031\001\102\001\110\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\134\001\019\001\255\255\021\001\255\255\
\023\001\000\000\025\001\255\255\255\255\255\255\029\001\030\001\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\255\255\255\255\255\255\255\255\255\255\000\000\
\255\255\255\255\255\255\031\001\255\255\255\255\255\255\255\255\
\110\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\134\001\019\001\255\255\021\001\255\255\023\001\000\000\025\001\
\255\255\255\255\255\255\029\001\030\001\031\001\255\255\110\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\134\001\
\255\255\255\255\255\255\255\255\255\255\000\000\255\255\255\255\
\255\255\019\001\255\255\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\029\001\030\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\000\000\
\255\255\255\255\255\255\255\255\110\001\255\000\000\001\001\001\
\002\001\003\001\004\001\005\001\006\001\007\001\008\001\009\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\018\001\255\255\255\255\255\255\134\001\255\255\255\255\255\255\
\255\255\255\255\000\000\255\255\255\255\255\255\019\001\255\255\
\021\001\255\255\023\001\255\255\025\001\255\255\255\255\255\255\
\255\255\255\255\031\001\255\255\110\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\134\001\019\001\255\255\021\001\
\000\000\023\001\255\255\025\001\255\255\255\255\255\255\255\255\
\255\255\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\255\255\000\000\
\255\255\255\255\255\255\255\255\019\001\255\255\021\001\255\255\
\023\001\255\255\025\001\255\255\255\255\255\255\255\255\255\255\
\031\001\110\001\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\255\255\255\255\255\255\255\255\255\255\
\255\255\134\001\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\255\255\255\255\031\001\255\255\
\110\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\255\255\255\255\255\255\255\255\255\255\000\000\255\255\
\134\001\019\001\255\255\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\255\255\255\255\031\001\255\255\110\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\255\255\255\255\
\255\255\255\255\005\000\255\255\255\255\255\255\255\255\134\001\
\019\001\255\255\021\001\255\255\023\001\255\255\025\001\255\255\
\255\255\255\255\255\255\255\255\031\001\110\001\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\134\001\255\255\255\255\
\255\255\255\255\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\110\001\255\255\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\255\255\
\255\255\000\000\255\255\255\255\134\001\019\001\255\255\021\001\
\255\255\023\001\255\255\025\001\255\255\255\255\255\255\255\255\
\255\255\031\001\255\255\110\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\134\001\255\255\255\255\255\255\130\000\
\255\255\255\255\255\255\019\001\255\255\021\001\255\255\023\001\
\255\255\025\001\255\255\255\255\255\255\110\001\255\255\031\001\
\147\000\148\000\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\000\000\255\255\255\255\014\001\
\255\255\255\255\019\001\018\001\021\001\134\001\023\001\022\001\
\025\001\255\255\255\255\174\000\255\255\255\255\031\001\255\255\
\110\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\255\255\255\255\041\001\255\255\255\255\192\000\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\052\001\255\255\255\255\
\134\001\255\255\205\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\220\000\255\255\255\255\255\255\255\255\110\001\255\255\
\000\000\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\237\000\013\001\014\001\255\255\016\001\017\001\
\018\001\255\255\020\001\021\001\099\001\255\255\134\001\255\255\
\255\255\027\001\028\001\106\001\000\000\110\001\032\001\033\001\
\255\255\255\255\036\001\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\124\001\255\255\126\001\
\050\001\051\001\052\001\255\255\255\255\134\001\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\255\255\
\082\001\083\001\084\001\085\001\086\001\087\001\088\001\089\001\
\090\001\091\001\092\001\093\001\094\001\255\255\255\255\097\001\
\098\001\255\255\255\255\101\001\102\001\103\001\255\255\255\255\
\106\001\255\255\255\255\255\255\110\001\255\255\112\001\255\255\
\114\001\115\001\116\001\117\001\118\001\119\001\120\001\121\001\
\122\001\123\001\255\255\125\001\126\001\127\001\128\001\014\001\
\130\001\016\001\017\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\117\001\255\255\255\255\036\001\255\255\255\255\
\255\255\255\255\125\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\135\001\255\255\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\016\001\017\001\255\255\255\255\
\255\255\096\001\097\001\098\001\255\255\255\255\101\001\102\001\
\103\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\112\001\255\255\114\001\115\001\116\001\117\001\118\001\
\119\001\120\001\121\001\122\001\123\001\255\255\255\255\255\255\
\255\255\128\001\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\014\001\014\001\255\255\
\255\255\018\001\018\001\019\001\255\255\255\255\022\001\255\255\
\255\255\255\255\255\255\255\255\096\001\097\001\255\255\255\255\
\255\255\101\001\102\001\035\001\036\001\255\255\255\255\255\255\
\041\001\041\001\014\001\255\255\255\255\255\255\018\001\019\001\
\255\255\255\255\022\001\052\001\052\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\128\001\255\255\255\255\035\001\
\036\001\255\255\255\255\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\052\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\099\001\099\001\255\255\255\255\255\255\255\255\
\255\255\106\001\106\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\124\001\124\001\126\001\126\001\099\001\
\005\001\006\001\007\001\008\001\009\001\255\255\106\001\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\124\001\255\255\126\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\092\001\
\093\001\094\001\255\255\255\255\097\001\255\255\099\001\255\255\
\101\001\102\001\255\255\255\255\255\255\106\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\124\001\
\255\255\126\001\127\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\135\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\092\001\
\093\001\094\001\255\255\255\255\097\001\255\255\099\001\255\255\
\101\001\102\001\255\255\255\255\255\255\106\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\124\001\
\255\255\126\001\127\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\135\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\092\001\
\093\001\094\001\255\255\255\255\097\001\255\255\099\001\255\255\
\101\001\102\001\255\255\255\255\255\255\106\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\124\001\
\255\255\126\001\127\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\135\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\092\001\
\093\001\094\001\255\255\255\255\097\001\255\255\099\001\255\255\
\101\001\102\001\255\255\255\255\255\255\106\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\124\001\
\255\255\126\001\127\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\135\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\092\001\
\093\001\094\001\255\255\255\255\097\001\255\255\099\001\255\255\
\101\001\102\001\255\255\255\255\255\255\106\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\255\255\124\001\
\255\255\126\001\127\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\135\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\092\001\
\093\001\094\001\255\255\255\255\097\001\255\255\099\001\255\255\
\101\001\102\001\255\255\255\255\255\255\106\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\255\255\124\001\
\255\255\126\001\127\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\135\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\092\001\
\093\001\094\001\255\255\255\255\097\001\255\255\099\001\255\255\
\101\001\102\001\255\255\255\255\255\255\106\001\255\255\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\124\001\
\020\001\126\001\127\001\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\135\001\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\255\255\082\001\083\001\
\084\001\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\255\255\255\255\097\001\098\001\255\255\
\255\255\101\001\102\001\103\001\255\255\255\255\106\001\107\001\
\108\001\255\255\255\255\255\255\112\001\255\255\114\001\115\001\
\116\001\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\124\001\125\001\126\001\127\001\128\001\255\255\130\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\016\001\017\001\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\255\255\082\001\083\001\084\001\085\001\
\086\001\087\001\088\001\089\001\090\001\091\001\092\001\093\001\
\094\001\255\255\255\255\097\001\098\001\255\255\255\255\101\001\
\102\001\103\001\255\255\255\255\106\001\255\255\108\001\255\255\
\255\255\255\255\112\001\255\255\114\001\115\001\116\001\117\001\
\118\001\119\001\120\001\121\001\122\001\123\001\124\001\125\001\
\126\001\127\001\128\001\255\255\130\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\255\255\082\001\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\255\255\
\255\255\097\001\098\001\255\255\255\255\101\001\102\001\103\001\
\255\255\255\255\106\001\255\255\255\255\255\255\110\001\255\255\
\112\001\255\255\114\001\115\001\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\255\255\125\001\126\001\127\001\
\128\001\255\255\130\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\255\255\016\001\017\001\
\018\001\255\255\020\001\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\036\001\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\255\255\
\082\001\083\001\084\001\085\001\086\001\087\001\088\001\089\001\
\090\001\091\001\092\001\093\001\094\001\255\255\255\255\097\001\
\098\001\255\255\255\255\101\001\102\001\103\001\255\255\255\255\
\106\001\255\255\255\255\255\255\110\001\255\255\112\001\255\255\
\114\001\115\001\116\001\117\001\118\001\119\001\120\001\121\001\
\122\001\123\001\255\255\125\001\126\001\127\001\128\001\255\255\
\130\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\255\255\082\001\083\001\
\084\001\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\255\255\255\255\097\001\098\001\255\255\
\255\255\101\001\102\001\103\001\255\255\255\255\106\001\255\255\
\255\255\255\255\110\001\255\255\112\001\255\255\114\001\115\001\
\116\001\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\255\255\125\001\126\001\127\001\128\001\255\255\130\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\016\001\017\001\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\255\255\082\001\083\001\084\001\085\001\
\086\001\087\001\088\001\089\001\090\001\091\001\092\001\093\001\
\094\001\255\255\255\255\097\001\098\001\255\255\255\255\101\001\
\102\001\103\001\255\255\255\255\106\001\255\255\255\255\255\255\
\255\255\255\255\112\001\255\255\114\001\115\001\116\001\117\001\
\118\001\119\001\120\001\121\001\122\001\123\001\255\255\125\001\
\126\001\127\001\128\001\255\255\130\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\255\255\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\255\255\082\001\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\255\255\
\255\255\097\001\098\001\255\255\255\255\101\001\102\001\255\255\
\255\255\255\255\106\001\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\014\001\013\001\014\001\017\001\
\018\001\017\001\018\001\255\255\020\001\125\001\126\001\127\001\
\128\001\255\255\130\001\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\076\001\077\001\078\001\079\001\255\255\255\255\
\080\001\255\255\082\001\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\255\255\
\255\255\255\255\098\001\255\255\102\001\005\001\006\001\007\001\
\008\001\009\001\106\001\255\255\255\255\013\001\014\001\255\255\
\255\255\017\001\018\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\125\001\126\001\127\001\
\032\001\033\001\130\001\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\014\001\255\255\255\255\255\255\018\001\255\255\005\001\
\006\001\007\001\008\001\009\001\092\001\093\001\094\001\013\001\
\014\001\097\001\255\255\017\001\018\001\101\001\102\001\036\001\
\255\255\255\255\106\001\255\255\041\001\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\255\255\052\001\
\038\001\255\255\255\255\041\001\255\255\255\255\126\001\127\001\
\128\001\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\255\255\
\255\255\255\255\255\255\255\255\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\255\255\099\001\255\255\
\255\255\255\255\255\255\255\255\255\255\106\001\092\001\093\001\
\094\001\255\255\255\255\097\001\255\255\255\255\255\255\255\255\
\102\001\255\255\255\255\255\255\106\001\255\255\255\255\124\001\
\255\255\126\001\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\126\001\127\001\017\001\018\001\255\255\020\001\021\001\022\001\
\255\255\024\001\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\255\255\017\001\018\001\255\255\020\001\021\001\022\001\
\255\255\024\001\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\017\001\018\001\255\255\020\001\255\255\022\001\
\255\255\024\001\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\023\001\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\023\001\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\036\001\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\023\001\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\019\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\019\001\255\255\255\255\014\001\
\255\255\255\255\255\255\018\001\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\035\001\092\001\093\001\094\001\
\255\255\255\255\041\001\050\001\051\001\052\001\005\001\006\001\
\007\001\008\001\009\001\106\001\255\255\052\001\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\126\001\
\127\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\092\001\093\001\094\001\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\255\255\106\001\099\001\255\255\255\255\255\255\
\255\255\255\255\255\255\106\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\126\001\
\127\001\255\255\255\255\255\255\255\255\124\001\255\255\126\001\
\255\255\255\255\255\255\255\255\255\255\092\001\093\001\094\001\
\255\255\014\001\015\001\255\255\017\001\018\001\019\001\020\001\
\255\255\022\001\255\255\106\001\025\001\255\255\255\255\255\255\
\255\255\030\001\255\255\255\255\255\255\255\255\035\001\036\001\
\255\255\255\255\255\255\255\255\041\001\255\255\255\255\126\001\
\127\001\255\255\255\255\255\255\255\255\255\255\255\255\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\095\001\255\255\097\001\255\255\255\255\255\255\
\101\001\102\001\103\001\255\255\014\001\106\001\255\255\017\001\
\018\001\019\001\255\255\112\001\022\001\255\255\255\255\025\001\
\255\255\255\255\255\255\255\255\121\001\122\001\123\001\255\255\
\255\255\126\001\036\001\128\001\255\255\255\255\255\255\041\001\
\255\255\134\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\014\001\255\255\255\255\255\255\018\001\
\019\001\255\255\255\255\022\001\255\255\255\255\025\001\097\001\
\255\255\099\001\014\001\101\001\102\001\017\001\018\001\019\001\
\106\001\036\001\022\001\255\255\110\001\025\001\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\036\001\052\001\124\001\255\255\126\001\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\134\001\255\255\255\255\255\255\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\099\001\014\001\255\255\255\255\255\255\018\001\019\001\106\001\
\255\255\022\001\255\255\110\001\025\001\097\001\255\255\099\001\
\255\255\101\001\102\001\255\255\255\255\255\255\106\001\036\001\
\255\255\124\001\110\001\126\001\041\001\255\255\014\001\255\255\
\255\255\014\001\018\001\134\001\255\255\018\001\019\001\052\001\
\124\001\022\001\126\001\255\255\025\001\255\255\255\255\255\255\
\255\255\255\255\134\001\035\001\036\001\255\255\014\001\036\001\
\255\255\041\001\018\001\019\001\041\001\255\255\022\001\255\255\
\255\255\025\001\255\255\255\255\052\001\255\255\255\255\052\001\
\255\255\255\255\255\255\255\255\036\001\255\255\255\255\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\099\001\255\255\
\255\255\255\255\255\255\255\255\052\001\106\001\255\255\255\255\
\255\255\110\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\124\001\
\255\255\126\001\255\255\099\001\255\255\255\255\099\001\255\255\
\255\255\134\001\106\001\255\255\255\255\106\001\255\255\255\255\
\255\255\110\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\124\001\255\255\126\001\124\001\
\255\255\126\001\106\001\255\255\255\255\017\001\110\001\019\001\
\020\001\134\001\255\255\255\255\255\255\025\001\255\255\255\255\
\255\255\255\255\030\001\255\255\124\001\255\255\126\001\035\001\
\036\001\255\255\255\255\255\255\255\255\255\255\134\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\095\001\255\255\097\001\098\001\099\001\
\255\255\101\001\102\001\103\001\255\255\255\255\255\255\017\001\
\255\255\019\001\020\001\255\255\112\001\255\255\255\255\025\001\
\255\255\255\255\255\255\255\255\030\001\121\001\122\001\123\001\
\124\001\035\001\036\001\255\255\128\001\255\255\255\255\255\255\
\255\255\255\255\134\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\095\001\255\255\097\001\
\098\001\099\001\255\255\101\001\102\001\103\001\255\255\014\001\
\255\255\255\255\017\001\018\001\255\255\255\255\112\001\022\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\121\001\
\122\001\123\001\124\001\255\255\255\255\036\001\128\001\255\255\
\255\255\255\255\041\001\255\255\134\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\014\001\255\255\255\255\017\001\018\001\
\255\255\255\255\097\001\022\001\099\001\255\255\101\001\102\001\
\255\255\255\255\255\255\106\001\255\255\255\255\255\255\110\001\
\035\001\036\001\255\255\255\255\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\124\001\255\255\126\001\
\255\255\052\001\255\255\255\255\131\001\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\016\001\017\001\255\255\255\255\255\255\
\021\001\255\255\255\255\255\255\255\255\255\255\097\001\255\255\
\099\001\255\255\101\001\102\001\255\255\255\255\255\255\106\001\
\255\255\255\255\255\255\110\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\124\001\255\255\126\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\016\001\017\001\255\255\255\255\255\255\
\021\001\255\255\255\255\096\001\097\001\255\255\255\255\255\255\
\101\001\102\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\255\255\255\255\255\255\128\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\255\255\
\020\001\255\255\255\255\096\001\097\001\025\001\255\255\255\255\
\101\001\102\001\030\001\255\255\255\255\255\255\255\255\255\255\
\036\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\128\001\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\017\001\
\255\255\255\255\020\001\095\001\255\255\097\001\255\255\025\001\
\255\255\101\001\102\001\103\001\030\001\255\255\255\255\255\255\
\255\255\255\255\036\001\255\255\112\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\121\001\122\001\123\001\
\255\255\255\255\255\255\255\255\128\001\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\017\001\255\255\255\255\020\001\095\001\255\255\097\001\
\255\255\025\001\255\255\101\001\102\001\103\001\030\001\255\255\
\255\255\255\255\255\255\255\255\036\001\255\255\112\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\121\001\
\122\001\123\001\255\255\255\255\255\255\255\255\128\001\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\017\001\255\255\255\255\020\001\255\255\255\255\095\001\
\255\255\097\001\255\255\255\255\255\255\101\001\102\001\103\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\112\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\121\001\122\001\123\001\255\255\255\255\255\255\255\255\
\128\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\017\001\255\255\255\255\020\001\255\255\255\255\255\255\
\255\255\097\001\255\255\255\255\255\255\101\001\102\001\103\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\112\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\121\001\122\001\123\001\255\255\255\255\255\255\255\255\
\128\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\014\001\255\255\
\255\255\017\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\255\255\255\255\255\255\101\001\102\001\255\255\
\255\255\255\255\255\255\255\255\036\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\128\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\255\255\255\255\255\255\
\255\255\255\255\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\015\001\255\255\017\001\255\255\019\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\255\255\255\255\255\255\255\255\102\001\103\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\112\001\255\255\114\001\115\001\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\015\001\
\255\255\017\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\097\001\255\255\099\001\255\255\
\101\001\102\001\034\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\124\001\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\015\001\255\255\017\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\255\255\099\001\255\255\101\001\102\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\124\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\015\001\
\255\255\017\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\097\001\255\255\099\001\
\255\255\101\001\102\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\124\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\255\255\099\001\255\255\101\001\102\001\255\255\
\255\255\255\255\255\255\255\255\018\001\255\255\255\255\255\255\
\022\001\255\255\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\255\255\255\255\124\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\018\001\255\255\255\255\255\255\022\001\
\255\255\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\255\255\255\255\255\255\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\018\001\255\255\255\255\021\001\022\001\255\255\
\024\001\025\001\026\001\027\001\028\001\255\255\014\001\031\001\
\110\001\017\001\255\255\035\001\255\255\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\110\001\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\015\001\255\255\017\001\
\255\255\255\255\255\255\255\255\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\102\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\017\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\097\001\
\255\255\255\255\255\255\101\001\102\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\017\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\097\001\255\255\
\255\255\255\255\101\001\102\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\255\255\255\255\255\255\255\255\255\255\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\097\001\255\255\255\255\
\255\255\255\255\102\001"

let yynames_const = "\
  "

let yynames_block = "\
  TUnknown\000\
  TCommentSpace\000\
  TCommentNewline\000\
  TComment\000\
  TInt\000\
  TFloat\000\
  TChar\000\
  TString\000\
  TQuote\000\
  TPct\000\
  TFormat\000\
  TSubString\000\
  TDecimal\000\
  TIdent\000\
  TKRParam\000\
  Tconstructorname\000\
  TypedefIdent\000\
  TOPar\000\
  TCPar\000\
  TOBrace\000\
  TCBrace\000\
  TOCro\000\
  TCCro\000\
  TDot\000\
  TComma\000\
  TPtrOp\000\
  TInc\000\
  TDec\000\
  TAssign\000\
  TEq\000\
  TWhy\000\
  TTilde\000\
  TBang\000\
  TEllipsis\000\
  TDotDot\000\
  TPtVirg\000\
  TOrLog\000\
  TAndLog\000\
  TOr\000\
  TXor\000\
  TAnd\000\
  TEqEq\000\
  TNotEq\000\
  TInf\000\
  TSup\000\
  TInfEq\000\
  TSupEq\000\
  TShl\000\
  TShr\000\
  TPlus\000\
  TMinus\000\
  TMul\000\
  TDiv\000\
  TMod\000\
  TMax\000\
  TMin\000\
  Tchar\000\
  Tshort\000\
  Tint\000\
  Tdouble\000\
  Tfloat\000\
  Tlong\000\
  Tunsigned\000\
  Tsigned\000\
  Tvoid\000\
  Tsize_t\000\
  Tssize_t\000\
  Tptrdiff_t\000\
  Tauto\000\
  Tregister\000\
  Textern\000\
  Tstatic\000\
  Ttypedef\000\
  Tconst\000\
  Tvolatile\000\
  Tstruct\000\
  Tunion\000\
  Tenum\000\
  Tdecimal\000\
  Tbreak\000\
  Telse\000\
  Tswitch\000\
  Tcase\000\
  Tcontinue\000\
  Tfor\000\
  Tdo\000\
  Tif\000\
  Twhile\000\
  Treturn\000\
  Tgoto\000\
  Tdefault\000\
  Tsizeof\000\
  Tnew\000\
  Tdelete\000\
  TOParCplusplusInit\000\
  Tnamespace\000\
  Trestrict\000\
  Tasm\000\
  Tattribute\000\
  TattributeNoarg\000\
  Tinline\000\
  Ttypeof\000\
  TDefine\000\
  TDefParamVariadic\000\
  TCppEscapedNewline\000\
  TCppConcatOp\000\
  TOParDefine\000\
  TOBraceDefineInit\000\
  TIdentDefine\000\
  TDefEOL\000\
  TInclude\000\
  TIncludeStart\000\
  TIncludeFilename\000\
  TIfdef\000\
  TIfdefelse\000\
  TIfdefelif\000\
  TEndif\000\
  TIfdefBool\000\
  TIfdefMisc\000\
  TIfdefVersion\000\
  TUndef\000\
  TPragma\000\
  TCppDirectiveOther\000\
  TMacroAttr\000\
  TMacroStmt\000\
  TMacroIdentBuilder\000\
  TMacroString\000\
  TMacroDecl\000\
  TMacroDeclConst\000\
  TMacroIterator\000\
  TMacroAttrStorage\000\
  TCommentSkipTagStart\000\
  TCommentSkipTagEnd\000\
  TCParEOL\000\
  TAction\000\
  TCommentMisc\000\
  TCommentCpp\000\
  EOF\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 647 "parser_c.mly"
                          ( _1 )
# 3102 "parser_c.ml"
               : Ast_c.program))
; (fun __caml_parser_env ->
    Obj.repr(
# 651 "parser_c.mly"
     ( [] )
# 3108 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 653 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; _1 ++ [_2] )
# 3116 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 655 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; 
       _1 ++ [Namespace (_5, [_2; snd _3; _4; _6])] )
# 3129 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 668 "parser_c.mly"
                ( _1 )
# 3136 "parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 669 "parser_c.mly"
                ( _1 )
# 3143 "parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 673 "parser_c.mly"
                ( _1 )
# 3150 "parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 682 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3157 "parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 683 "parser_c.mly"
                   ( _1 )
# 3164 "parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 687 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3171 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 689 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3178 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 690 "parser_c.mly"
                   ( _1 )
# 3185 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp_list) in
    Obj.repr(
# 694 "parser_c.mly"
     (
       CppConcatenatedName (
         match _3 with
         | [] -> raise (Impossible 87)
         | (x,concatnull)::xs ->
             assert(null concatnull);
             (mk_string_wrap _1, [])::(x,[_2])::xs
       )
   )
# 3202 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 704 "parser_c.mly"
     ( CppVariadicName (fst _2, [_1; snd _2]) )
# 3210 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'param_define_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 706 "parser_c.mly"
     ( CppIdentBuilder ((fst _1, [snd _1;_2;_4]), _3) )
# 3220 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 709 "parser_c.mly"
          ( [mk_string_wrap _1, []] )
# 3227 "parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 710 "parser_c.mly"
                                           ( _1 ++ [mk_string_wrap _3, [_2]] )
# 3236 "parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 717 "parser_c.mly"
                           ( _1 )
# 3243 "parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 718 "parser_c.mly"
                           ( mk_e (Sequence (_1,_3)) [_2] )
# 3252 "parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 724 "parser_c.mly"
                                 ( _1 )
# 3259 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.assignOp * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 725 "parser_c.mly"
                                 ( mk_e(Assignment (_1,fst _2,_3)) [snd _2])
# 3268 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 726 "parser_c.mly"
                                 ( mk_e(Assignment (_1,SimpleAssign,_3)) [_2])
# 3277 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 734 "parser_c.mly"
     ( _1 )
# 3284 "parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_opt_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 736 "parser_c.mly"
     ( mk_e (CondExpr (_1,_3,_5)) [_2;_4] )
# 3295 "parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 740 "parser_c.mly"
                                 ( _1 )
# 3302 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 741 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Mul,      _3)) [_2] )
# 3311 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 742 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Div,      _3)) [_2] )
# 3320 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 743 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Min,      _3)) [_2] )
# 3329 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 744 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Max,      _3)) [_2] )
# 3338 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 745 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Mod,      _3)) [_2] )
# 3347 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 746 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Plus,     _3)) [_2] )
# 3356 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 747 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Minus,    _3)) [_2] )
# 3365 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 748 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith DecLeft,  _3)) [_2] )
# 3374 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 749 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith DecRight, _3)) [_2] )
# 3383 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 750 "parser_c.mly"
                                 ( mk_e(Binary (_1, Logical Inf,    _3)) [_2] )
# 3392 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 751 "parser_c.mly"
                                 ( mk_e(Binary (_1, Logical Sup,    _3)) [_2] )
# 3401 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 752 "parser_c.mly"
                                 ( mk_e(Binary (_1, Logical InfEq,  _3)) [_2] )
# 3410 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 753 "parser_c.mly"
                                 ( mk_e(Binary (_1, Logical SupEq,  _3)) [_2] )
# 3419 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 754 "parser_c.mly"
                                 ( mk_e(Binary (_1, Logical Eq,     _3)) [_2] )
# 3428 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 755 "parser_c.mly"
                                 ( mk_e(Binary (_1, Logical NotEq,  _3)) [_2] )
# 3437 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 756 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith And,      _3)) [_2] )
# 3446 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 757 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Or,       _3)) [_2] )
# 3455 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 758 "parser_c.mly"
                                 ( mk_e(Binary (_1, Arith Xor,      _3)) [_2] )
# 3464 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 759 "parser_c.mly"
                                 ( mk_e(Binary (_1, Logical AndLog, _3)) [_2] )
# 3473 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 760 "parser_c.mly"
                                 ( mk_e(Binary (_1, Logical OrLog,  _3)) [_2] )
# 3482 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 763 "parser_c.mly"
                                     ( _1 )
# 3489 "parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 764 "parser_c.mly"
                                     ( mk_e(Cast (_2, _4)) [_1;_3] )
# 3499 "parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expr) in
    Obj.repr(
# 767 "parser_c.mly"
                                   ( _1 )
# 3506 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 768 "parser_c.mly"
                                   ( mk_e(Infix (_2, Inc))    [_1] )
# 3514 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 769 "parser_c.mly"
                                   ( mk_e(Infix (_2, Dec))    [_1] )
# 3522 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unary_op) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 770 "parser_c.mly"
                                   ( mk_e(Unary (_2, fst _1)) [snd _1] )
# 3530 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 771 "parser_c.mly"
                                   ( mk_e(SizeOfExpr (_2))    [_1] )
# 3538 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar2) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar2) in
    Obj.repr(
# 772 "parser_c.mly"
                                   ( mk_e(SizeOfType (_3))    [_1;_2;_4] )
# 3548 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 773 "parser_c.mly"
                                   ( mk_e(New (None, _2))     [_1] )
# 3556 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 774 "parser_c.mly"
                                                  ( mk_e(New (Some _3, _5))             [_1; _2; _4] )
# 3567 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 775 "parser_c.mly"
                                   ( mk_e(Delete _2)          [_1] )
# 3575 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 779 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3586 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 782 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left(mk_e(FunCall (fn, [])) [_2;_3]) )
# 3596 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 785 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3607 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 788 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, [])) [_2;_3]) )
# 3617 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 791 "parser_c.mly"
     ( let ty = addTypeD (_1,nullDecl) in
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam ty in
       Right (ArgType { p_namei = None; p_type = returnType;
			p_register = hasreg, iihasreg;
		      } )
     )
# 3629 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'new_argument) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 798 "parser_c.mly"
     (
       match _1 with
	 Left(e) -> Left(mk_e(ArrayAccess (e, _3)) [_2;_4])
       | Right(ArgType(ty)) -> (* lots of hacks to make the right type *)
	   let fty = mk_ty (Array (Some _3, ty.Ast_c.p_type)) [_2;_4] in
	   let pty = { ty with p_type = fty } in
	   Right(ArgType pty)
       | _ -> raise (Impossible 88)
     )
# 3647 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 809 "parser_c.mly"
          ( GetRef,     _1 )
# 3654 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 810 "parser_c.mly"
          ( DeRef,      _1 )
# 3661 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 811 "parser_c.mly"
          ( UnPlus,     _1 )
# 3668 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 812 "parser_c.mly"
          ( UnMinus,    _1 )
# 3675 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 813 "parser_c.mly"
          ( Tilde,      _1 )
# 3682 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 814 "parser_c.mly"
          ( Not,        _1 )
# 3689 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 818 "parser_c.mly"
           ( GetRefLabel, _1 )
# 3696 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expr) in
    Obj.repr(
# 821 "parser_c.mly"
                              ( _1 )
# 3703 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 823 "parser_c.mly"
     ( mk_e(ArrayAccess (_1, _3)) [_2;_4] )
# 3713 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 825 "parser_c.mly"
     ( mk_e(FunCall (_1, _3)) [_2;_4] )
# 3723 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 826 "parser_c.mly"
                              ( mk_e(FunCall (_1, [])) [_2;_3] )
# 3732 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 827 "parser_c.mly"
                                 ( mk_e(RecordAccess   (_1,_3)) [_2] )
# 3741 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 828 "parser_c.mly"
                                 ( mk_e(RecordPtAccess (_1,_3)) [_2] )
# 3750 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 829 "parser_c.mly"
                              ( mk_e(Postfix (_1, Inc)) [_2] )
# 3758 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 830 "parser_c.mly"
                              ( mk_e(Postfix (_1, Dec)) [_2] )
# 3766 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 834 "parser_c.mly"
     ( mk_e(Constructor (_2, (InitList [], [_4;_5]))) [_1;_3] )
# 3777 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 836 "parser_c.mly"
     ( mk_e(Constructor (_2, (InitList (List.rev _5),[_4;_7]++_6))) [_1;_3] )
# 3790 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 840 "parser_c.mly"
                   ( mk_e(Ident  (_1)) [] )
# 3797 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 842 "parser_c.mly"
    ( let (str,(sign,base)) = fst _1 in
      mk_e(Constant (Int (str,Si(sign,base)))) [snd _1] )
# 3805 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 844 "parser_c.mly"
           ( mk_e(Constant (Float  (fst _1))) [snd _1] )
# 3812 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 845 "parser_c.mly"
           ( mk_e(Constant (String (fst _1))) [snd _1] )
# 3819 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragments) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 847 "parser_c.mly"
     ( let ((fullstring,isW),lqinfo) = _1 in
       let (_,rqinfo) = _3 in
       mk_e (Ast_c.StringConstant(_2, fullstring, isW)) [lqinfo;rqinfo] )
# 3830 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 850 "parser_c.mly"
           ( mk_e(Constant (Char   (fst _1))) [snd _1] )
# 3837 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * string (*n*) * string (*p*)) * Ast_c.info) in
    Obj.repr(
# 851 "parser_c.mly"
            ( let (a,b,c) = fst _1 in
              mk_e(Constant (DecimalConst (a,b,c))) [snd _1] )
# 3845 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 853 "parser_c.mly"
                    ( mk_e(ParenExpr (_2)) [_1;_3] )
# 3854 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 856 "parser_c.mly"
                ( mk_e(Constant (MultiString [fst _1])) [snd _1] )
# 3861 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_elem) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 858 "parser_c.mly"
     ( mk_e(Constant (MultiString ["TODO: MultiString"])) (_1 ++ _2) )
# 3869 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 861 "parser_c.mly"
                         ( mk_e(StatementExpr (_2)) [_1;_3] )
# 3878 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 864 "parser_c.mly"
               ( [] )
# 3884 "parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragment) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_fragments) in
    Obj.repr(
# 865 "parser_c.mly"
                                    ( _1 :: _2 )
# 3892 "parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_format) in
    Obj.repr(
# 868 "parser_c.mly"
                      ( Ast_c.FormatFragment(_2), [_1] )
# 3900 "parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 869 "parser_c.mly"
              ( Ast_c.ConstantFragment(fst _1), [snd _1] )
# 3907 "parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 872 "parser_c.mly"
           ( Ast_c.ConstantFormat(fst _1), [snd _1] )
# 3914 "parser_c.ml"
               : 'string_format))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 881 "parser_c.mly"
               ( Left _1 )
# 3921 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 882 "parser_c.mly"
                  ( Right (ArgType _1)  )
# 3928 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro_ne) in
    Obj.repr(
# 883 "parser_c.mly"
                              ( Right (ArgAction _1) )
# 3935 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 887 "parser_c.mly"
               ( Left _1 )
# 3942 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 888 "parser_c.mly"
                  ( Right (ArgType _1)  )
# 3949 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro) in
    Obj.repr(
# 890 "parser_c.mly"
                           ( Right (ArgAction _1) )
# 3956 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 894 "parser_c.mly"
     ( if null _1
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 3966 "parser_c.ml"
               : 'action_higherordermacro_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 902 "parser_c.mly"
     ( if null _1
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 3976 "parser_c.ml"
               : 'action_higherordermacro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 913 "parser_c.mly"
                      ( _1  )
# 3983 "parser_c.ml"
               : 'const_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 916 "parser_c.mly"
              ( et "topar2" (); _1  )
# 3990 "parser_c.ml"
               : 'topar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 917 "parser_c.mly"
              ( et "tcpar2" (); _1 (*TODO? et ? sure ? c pas dt plutot ? *) )
# 3997 "parser_c.ml"
               : 'tcpar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'statement2) in
    Obj.repr(
# 925 "parser_c.mly"
                      ( mk_st (fst _1) (snd _1) )
# 4004 "parser_c.ml"
               : Ast_c.statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'labeled) in
    Obj.repr(
# 928 "parser_c.mly"
                   ( Labeled      (fst _1), snd _1 )
# 4011 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 929 "parser_c.mly"
                   ( Compound     (fst _1), snd _1 )
# 4018 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expr_statement) in
    Obj.repr(
# 930 "parser_c.mly"
                   ( ExprStatement(fst _1), snd _1 )
# 4025 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection) in
    Obj.repr(
# 931 "parser_c.mly"
                   ( Selection    (fst _1), snd _1 ++ [fakeInfo()] )
# 4032 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iteration) in
    Obj.repr(
# 932 "parser_c.mly"
                   ( Iteration    (fst _1), snd _1 ++ [fakeInfo()] )
# 4039 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'jump) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 933 "parser_c.mly"
                   ( Jump         (fst _1), snd _1 ++ [_2] )
# 4047 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 936 "parser_c.mly"
                                                ( Asm _3, [_1;_2;_4;_5] )
# 4058 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 937 "parser_c.mly"
                                                ( Asm _4, [_1;_2;_3;_5;_6] )
# 4070 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 940 "parser_c.mly"
              ( MacroStmt, [snd _1] )
# 4077 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 949 "parser_c.mly"
                                              ( Label (_1, _3),  [_2] )
# 4086 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 950 "parser_c.mly"
                                              ( Case (_2, _4),       [_1; _3] )
# 4096 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 952 "parser_c.mly"
     ( CaseRange (_2, _4, _6), [_1;_3;_5] )
# 4108 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 953 "parser_c.mly"
                                         ( Default _3,             [_1; _2] )
# 4117 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 956 "parser_c.mly"
             ( mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii )
# 4124 "parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 957 "parser_c.mly"
             ( _1 )
# 4131 "parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 968 "parser_c.mly"
     ( Label (_1, (mk_st (ExprStatement None) Ast_c.noii)), [_2] )
# 4139 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 970 "parser_c.mly"
     ( Case (_2, (mk_st (ExprStatement None) Ast_c.noii)), [_1;_3] )
# 4148 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 972 "parser_c.mly"
     ( Default (mk_st (ExprStatement None) Ast_c.noii),    [_1; _2] )
# 4156 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace) in
    Obj.repr(
# 978 "parser_c.mly"
                                    ( _2, [_1; _3]  )
# 4165 "parser_c.ml"
               : 'compound))
; (fun __caml_parser_env ->
    Obj.repr(
# 990 "parser_c.mly"
                     ( ([]) )
# 4171 "parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 991 "parser_c.mly"
                     ( _1 )
# 4178 "parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl) in
    Obj.repr(
# 995 "parser_c.mly"
                                  ( [_1] )
# 4185 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_labeled) in
    Obj.repr(
# 997 "parser_c.mly"
                ( [StmtElem (mk_st (Labeled  (fst _1)) (snd _1))] )
# 4192 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 999 "parser_c.mly"
                                  ( _1 :: _2 )
# 4200 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1002 "parser_c.mly"
             ( StmtElem (mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii) )
# 4207 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1003 "parser_c.mly"
             ( StmtElem _1 )
# 4214 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1006 "parser_c.mly"
                       ( StmtElem (mk_st (NestedFunc _1) Ast_c.noii) )
# 4221 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1010 "parser_c.mly"
     ( CppDirectiveStmt _1 )
# 4228 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1012 "parser_c.mly"
     ( IfdefStmt _1 )
# 4235 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1016 "parser_c.mly"
                ( None,    [_1] )
# 4242 "parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1017 "parser_c.mly"
                ( Some _1, [_2] )
# 4250 "parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1021 "parser_c.mly"
     ( If (_3, _5, (mk_st (ExprStatement None) Ast_c.noii)),   [_1;_2;_4] )
# 4261 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1023 "parser_c.mly"
     ( If (_3, _5, _7),  [_1;_2;_4;_6] )
# 4274 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1025 "parser_c.mly"
     ( Switch (_3,_5),   [_1;_2;_4]  )
# 4285 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1029 "parser_c.mly"
     ( While (_3,_5),                [_1;_2;_4] )
# 4296 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1031 "parser_c.mly"
     ( DoWhile (_2,_5),              [_1;_3;_4;_6;_7] )
# 4309 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1033 "parser_c.mly"
     ( For (ForExp _3,_4,(None, []),_6),    [_1;_2;_5])
# 4321 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1035 "parser_c.mly"
     ( For (ForExp _3,_4,(Some _5, []),_7), [_1;_2;_6] )
# 4334 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1038 "parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(None, []),_6),    [_1;_2;_5])
# 4346 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1040 "parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(Some _5, []),_7), [_1;_2;_6] )
# 4359 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1043 "parser_c.mly"
     ( MacroIteration (fst _1, _3, _5), [snd _1;_2;_4] )
# 4370 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1045 "parser_c.mly"
     ( MacroIteration (fst _1, [], _4), [snd _1;_2;_3] )
# 4380 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1049 "parser_c.mly"
                    ( Goto (_2),  [_1] )
# 4388 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1050 "parser_c.mly"
                ( Continue,       [_1] )
# 4395 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1051 "parser_c.mly"
                ( Break,          [_1] )
# 4402 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1052 "parser_c.mly"
                ( Return,         [_1] )
# 4409 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1053 "parser_c.mly"
                ( ReturnExpr _2,  [_1] )
# 4417 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1054 "parser_c.mly"
                   ( GotoComputed _3, [_1;_2] )
# 4426 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1062 "parser_c.mly"
           ( [snd _1] )
# 4433 "parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1064 "parser_c.mly"
                ( [snd _1] )
# 4440 "parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm_list) in
    Obj.repr(
# 1068 "parser_c.mly"
                               ( _1, _2 )
# 4448 "parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 1069 "parser_c.mly"
               ( _1, [] )
# 4455 "parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option_list) in
    Obj.repr(
# 1072 "parser_c.mly"
                                     ( Colon _2, [_1]   )
# 4463 "parser_c.ml"
               : 'colon_asm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1075 "parser_c.mly"
                                ( ColonMisc, [snd _1] )
# 4470 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1076 "parser_c.mly"
                                ( ColonExpr _3, [snd _1; _2;_4] )
# 4480 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1079 "parser_c.mly"
     ( ColonExpr _6, [_1;snd _2;_3;snd _4; _5; _7 ] )
# 4493 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 1080 "parser_c.mly"
                                    ( ColonMisc, [snd _1] )
# 4500 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1081 "parser_c.mly"
                                    ( ColonMisc, [] )
# 4506 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1083 "parser_c.mly"
                      ( _1 )
# 4513 "parser_c.ml"
               : 'asm_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1094 "parser_c.mly"
                        ( Right3 (BaseType Void),            [_1] )
# 4520 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1095 "parser_c.mly"
                        ( Right3 (BaseType (IntType CChar)), [_1])
# 4527 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1096 "parser_c.mly"
                        ( Right3 (BaseType (IntType (Si (Signed,CInt)))), [_1])
# 4534 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1097 "parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloat)),  [_1])
# 4541 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1098 "parser_c.mly"
                        ( Right3 (BaseType (FloatType CDouble)), [_1] )
# 4548 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1099 "parser_c.mly"
                        ( Right3 (BaseType SizeType),            [_1] )
# 4555 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1100 "parser_c.mly"
                        ( Right3 (BaseType SSizeType),           [_1] )
# 4562 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1101 "parser_c.mly"
                        ( Right3 (BaseType PtrDiffType),         [_1] )
# 4569 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1102 "parser_c.mly"
                        ( Middle3 Short,  [_1])
# 4576 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1103 "parser_c.mly"
                        ( Middle3 Long,   [_1])
# 4583 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1104 "parser_c.mly"
                        ( Left3 Signed,   [_1])
# 4590 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1105 "parser_c.mly"
                        ( Left3 UnSigned, [_1])
# 4597 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union_spec) in
    Obj.repr(
# 1106 "parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 4604 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enum_spec) in
    Obj.repr(
# 1107 "parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 4611 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1109 "parser_c.mly"
     ( Right3 (Decimal(_3,Some _5)), [_1;_2;_4;_6] )
# 4623 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1111 "parser_c.mly"
     ( Right3 (Decimal(_3,None)), [_1;_2;_4] )
# 4633 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1127 "parser_c.mly"
     ( let name = RegularName (mk_string_wrap _1) in
       Right3 (TypeName (name, Ast_c.noTypedefDef())),[] )
# 4641 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'assign_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1130 "parser_c.mly"
                                   ( Right3 (TypeOfExpr (_3)), [_1;_2;_4] )
# 4651 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1131 "parser_c.mly"
                                   ( Right3 (TypeOfType (_3)), [_1;_2;_4] )
# 4661 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec2) in
    Obj.repr(
# 1137 "parser_c.mly"
                         ( dt "type" (); _1   )
# 4668 "parser_c.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1144 "parser_c.mly"
             ( {const=true  ; volatile=false}, _1 )
# 4675 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1145 "parser_c.mly"
             ( {const=false ; volatile=true},  _1 )
# 4682 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1147 "parser_c.mly"
             ( (* TODO *) {const=false ; volatile=false},  _1 )
# 4689 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1155 "parser_c.mly"
                                    ( raise Todo )
# 4698 "parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1157 "parser_c.mly"
              ( Attribute (fst _1), [snd _1] )
# 4705 "parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1160 "parser_c.mly"
                     ( _1 )
# 4712 "parser_c.ml"
               : 'attribute_storage))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1163 "parser_c.mly"
               ( _1 )
# 4719 "parser_c.ml"
               : 'type_qualif_attr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1165 "parser_c.mly"
              ( {const=true  ; volatile=false}, snd _1   )
# 4726 "parser_c.ml"
               : 'type_qualif_attr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1180 "parser_c.mly"
                    ( (fst _2, fun x -> x +> _1 +> (snd _2)  ) )
# 4734 "parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1181 "parser_c.mly"
                    ( _1  )
# 4741 "parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tmul) in
    Obj.repr(
# 1185 "parser_c.mly"
                          ( fun x -> mk_ty (Pointer x) [_1] )
# 4748 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1186 "parser_c.mly"
                          ( fun x -> mk_ty (Pointer (_2 x)) [_1] )
# 4756 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_list) in
    Obj.repr(
# 1188 "parser_c.mly"
     ( fun x -> (_2.qualifD, mk_tybis (Pointer x) [_1]))
# 4764 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1190 "parser_c.mly"
     ( fun x -> (_2.qualifD, mk_tybis (Pointer (_3 x)) [_1]) )
# 4773 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1193 "parser_c.mly"
        ( _1 )
# 4780 "parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1195 "parser_c.mly"
     ( if !Flag.c_plus_plus
     then _1
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("& not allowed in C types, try -c++ option", i)) )
# 4791 "parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 1204 "parser_c.mly"
     ( (_1, fun x -> x) )
# 4798 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1206 "parser_c.mly"
     ( (fst _2, fun x -> mk_ty (ParenType ((snd _2) x)) [_1;_3]) )
# 4807 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1208 "parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (None,x)) [_2;_3])) )
# 4816 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1210 "parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (Some _3,x)) [_2;_4])) )
# 4826 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1212 "parser_c.mly"
     ( (fst _1,
       fun x->(snd _1)
         (mk_ty (FunctionType (x,(([],(false, []))))) [_2;_3]))
     )
# 4838 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1217 "parser_c.mly"
     ( (fst _1,fun x->(snd _1)
       (mk_ty (FunctionType (x, _3)) [_2;_4]))
     )
# 4850 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1226 "parser_c.mly"
             ( et "tocro" ();_1 )
# 4857 "parser_c.ml"
               : 'tocro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1227 "parser_c.mly"
             ( dt "tccro" ();_1 )
# 4864 "parser_c.ml"
               : 'tccro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1231 "parser_c.mly"
                                      ( _1 )
# 4871 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1232 "parser_c.mly"
                                      ( _1 )
# 4878 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1233 "parser_c.mly"
                                      ( fun x -> x +> _2 +> _1 )
# 4886 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abstract_declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1237 "parser_c.mly"
     ( fun x -> mk_ty (ParenType (_2 x)) [_1;_3] )
# 4895 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1240 "parser_c.mly"
     ( fun x -> mk_ty (Array (None, x)) [_1;_2] )
# 4903 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1242 "parser_c.mly"
     ( fun x -> mk_ty (Array (Some _2, x)) [_1;_3] )
# 4912 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1244 "parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (None, x))  [_2;_3]) )
# 4921 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1246 "parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (Some _3,x))  [_2;_4]) )
# 4931 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1248 "parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, ([], (false,  [])))) [_1;_2] )
# 4939 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1250 "parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, _2))  [_1;_3] )
# 4948 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1261 "parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, (([], (false, []))))) [_2;_3]) )
# 4957 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1263 "parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, _3)) [_2;_4]) )
# 4967 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_list) in
    Obj.repr(
# 1269 "parser_c.mly"
                                   ( (_1, (false, [])))
# 4974 "parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1270 "parser_c.mly"
                                   ( (_1, (true,  [_2;_3])) )
# 4983 "parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1274 "parser_c.mly"
            (
     let name = RegularName (mk_string_wrap _1) in
     LP.add_ident (str_of_name name);
     { p_namei = Some name;
       p_type = mk_ty NoType [];
       p_register = (false, []);
     }
   )
# 4997 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorp) in
    Obj.repr(
# 1283 "parser_c.mly"
     ( let ((returnType,hasreg),iihasreg) = fixDeclSpecForParam _1 in
       let (name, ftyp) = _2 in
       { p_namei = Some (name);
         p_type = ftyp returnType;
         p_register = (hasreg, iihasreg);
       }
     )
# 5011 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratorp) in
    Obj.repr(
# 1291 "parser_c.mly"
     ( let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam _1 in
       { p_namei = None;
         p_type = _2 returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5024 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1298 "parser_c.mly"
     ( let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam _1 in
       { p_namei = None;
         p_type = returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5036 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1310 "parser_c.mly"
                                ( et "param" ();  _1 )
# 5043 "parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1311 "parser_c.mly"
                              ( et "param" (); _2 )
# 5051 "parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1314 "parser_c.mly"
               ( LP.add_ident (str_of_name (fst _1)); _1 )
# 5058 "parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1316 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _2)); _2 )
# 5066 "parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1317 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _1)); _1 )
# 5074 "parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1320 "parser_c.mly"
                       ( _1 )
# 5081 "parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1322 "parser_c.mly"
                                  ( _2 )
# 5089 "parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1331 "parser_c.mly"
                                ( addTypeD (_1, nullDecl) )
# 5096 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1332 "parser_c.mly"
                                ( {nullDecl with qualifD = (fst _1,[snd _1])})
# 5103 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1333 "parser_c.mly"
                                ( addTypeD (_1,_2)   )
# 5111 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1334 "parser_c.mly"
                                ( addQualifD (_1,_2) )
# 5119 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list2) in
    Obj.repr(
# 1336 "parser_c.mly"
                                               (  dt "spec_qualif" (); _1 )
# 5126 "parser_c.ml"
               : 'spec_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_attr) in
    Obj.repr(
# 1341 "parser_c.mly"
                                     ( {nullDecl with qualifD = (fst _1,[snd _1])} )
# 5133 "parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_attr) in
    Obj.repr(
# 1342 "parser_c.mly"
                                     ( addQualifD (_2,_1) )
# 5141 "parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1355 "parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in  returnType )
# 5148 "parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratort) in
    Obj.repr(
# 1357 "parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in _2 returnType )
# 5156 "parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1362 "parser_c.mly"
                       ( _1 )
# 5163 "parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1364 "parser_c.mly"
                                  ( _2 )
# 5171 "parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1373 "parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       let iistart = Ast_c.fakeInfo () in
       DeclList ([{v_namei = None; v_type = returnType;
                   v_storage = unwrap storage; v_local = local;
                   v_attr = Ast_c.noattr;
                   v_type_bis = ref None;
                },[]],
                (_2::iistart::snd storage))
     )
# 5188 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'init_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1384 "parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       let iistart = Ast_c.fakeInfo () in
       DeclList (
         (_2 +> List.map (fun ((((name,f),attrs), ini), iivirg) ->
           let s = str_of_name name in
	   if fst (unwrap storage) =*= StoTypedef
	   then LP.add_typedef s;
           {v_namei = Some (name, ini);
            v_type = f returnType;
            v_storage = unwrap storage;
            v_local = local;
            v_attr = attrs;
            v_type_bis = ref None;
           },
           iivirg
         )
         ),  (_3::iistart::snd storage))
     )
# 5215 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1406 "parser_c.mly"
     ( function _ ->
       MacroDecl ((fst _1, _3, true), [snd _1;_2;_4;_5;fakeInfo()]) )
# 5227 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1409 "parser_c.mly"
     ( function _ ->
       MacroDecl ((fst _2, _4, true), [snd _2;_3;_5;_6;fakeInfo();_1]) )
# 5240 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1412 "parser_c.mly"
     ( function _ ->
       MacroDecl ((fst _3, _5, true), [snd _3;_4;_6;_7;fakeInfo();_1;_2]))
# 5254 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1417 "parser_c.mly"
     ( function _ ->
       MacroDeclInit ((fst _1, _3, _6), [snd _1;_2;_4;_5;_7;fakeInfo()]) )
# 5268 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _8 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1420 "parser_c.mly"
     ( function _ ->
       MacroDeclInit ((fst _2, _4, _7),[snd _2;_3;_5;_6;_8;fakeInfo();_1]) )
# 5283 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _9 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1424 "parser_c.mly"
     ( function _ ->
       MacroDeclInit
	 ((fst _3, _5, _8), [snd _3;_4;_6;_7;_9;fakeInfo();_1;_2]))
# 5300 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec) in
    Obj.repr(
# 1431 "parser_c.mly"
                           ( {nullDecl with storageD = (fst _1, [snd _1]) } )
# 5307 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1432 "parser_c.mly"
                           ( addTypeD (_1,nullDecl) )
# 5314 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1433 "parser_c.mly"
                           ( {nullDecl with qualifD  = (fst _1, [snd _1]) } )
# 5321 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1434 "parser_c.mly"
                           ( {nullDecl with inlineD = (true, [_1]) } )
# 5328 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1435 "parser_c.mly"
                                 ( addStorageD (_1, _2) )
# 5336 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1436 "parser_c.mly"
                                 ( addTypeD    (_1, _2) )
# 5344 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1437 "parser_c.mly"
                                 ( addQualifD  (_1, _2) )
# 5352 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1438 "parser_c.mly"
                                 ( addInlineD ((true, _1), _2) )
# 5360 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1446 "parser_c.mly"
                ( Sto Static,  _1 )
# 5367 "parser_c.ml"
               : 'storage_class_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1447 "parser_c.mly"
                ( Sto Extern,  _1 )
# 5374 "parser_c.ml"
               : 'storage_class_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1448 "parser_c.mly"
                ( Sto Auto,    _1 )
# 5381 "parser_c.ml"
               : 'storage_class_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1449 "parser_c.mly"
                ( Sto Register,_1 )
# 5388 "parser_c.ml"
               : 'storage_class_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1450 "parser_c.mly"
                ( StoTypedef,  _1 )
# 5395 "parser_c.ml"
               : 'storage_class_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec2) in
    Obj.repr(
# 1454 "parser_c.mly"
                       ( _1 )
# 5402 "parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec2) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_storage_list) in
    Obj.repr(
# 1455 "parser_c.mly"
                                              ( _1 (* TODO *) )
# 5410 "parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl2) in
    Obj.repr(
# 1463 "parser_c.mly"
                         ( et "decl" (); _1 )
# 5417 "parser_c.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1464 "parser_c.mly"
                         ( dt "declspec" (); _1  )
# 5424 "parser_c.ml"
               : 'decl_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1470 "parser_c.mly"
                                ( (_1, NoInit) )
# 5431 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1471 "parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 5440 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1474 "parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 5450 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1480 "parser_c.mly"
          ( et "teq" (); _1 )
# 5457 "parser_c.ml"
               : 'teq))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator2) in
    Obj.repr(
# 1482 "parser_c.mly"
                                   ( dt "init" (); _1 )
# 5464 "parser_c.ml"
               : 'init_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1490 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _1)); _1, Ast_c.noattr )
# 5471 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'gcc_asm_decl) in
    Obj.repr(
# 1492 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _1)); _1, Ast_c.noattr )
# 5479 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1494 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _2)); _2, _1 )
# 5487 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1495 "parser_c.mly"
                           ( LP.add_ident (str_of_name (fst _1)); _1, Ast_c.noattr (* TODO *) )
# 5495 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1500 "parser_c.mly"
                                         (  )
# 5505 "parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1501 "parser_c.mly"
                                        (  )
# 5516 "parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1507 "parser_c.mly"
     ( InitExpr _1,                [] )
# 5523 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1509 "parser_c.mly"
     ( InitList (List.rev _2),     [_1;_4]++_3 )
# 5533 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1511 "parser_c.mly"
     ( InitList [],       [_1;_2] )
# 5541 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1522 "parser_c.mly"
                                      ( [_1,   []] )
# 5548 "parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1523 "parser_c.mly"
                                      ( (_3,  [_2])::_1 )
# 5557 "parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 1529 "parser_c.mly"
     ( InitExpr _1,   [] )
# 5564 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1531 "parser_c.mly"
     ( InitList (List.rev _2),   [_1;_4]++_3 )
# 5574 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1533 "parser_c.mly"
     ( InitList [],  [_1;_2]  )
# 5582 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1537 "parser_c.mly"
     ( InitDesignators (_1, _3), [_2] )
# 5591 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1541 "parser_c.mly"
     ( InitFieldOld (fst _1, _3),     [snd _1; _2] )
# 5600 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1552 "parser_c.mly"
     ( DesignatorField (fst _2), [_1;snd _2] )
# 5608 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1554 "parser_c.mly"
     ( DesignatorIndex (_2),  [_1;_3] )
# 5617 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1556 "parser_c.mly"
     ( DesignatorRange (_2, _4),  [_1;_3;_5] )
# 5628 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1564 "parser_c.mly"
          (  [_1] )
# 5635 "parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    Obj.repr(
# 1565 "parser_c.mly"
                    (  [Ast_c.fakeInfo() +> Ast_c.rewrap_str ","]  )
# 5641 "parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1580 "parser_c.mly"
     ( StructUnion (fst _1, Some (fst _2), _4),  [snd _1;snd _2;_3;_5]  )
# 5652 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1582 "parser_c.mly"
     ( StructUnion (fst _1, None, _3), [snd _1;_2;_4] )
# 5662 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1584 "parser_c.mly"
     ( StructUnionName (fst _1, fst _2), [snd _1;snd _2] )
# 5670 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1587 "parser_c.mly"
             ( Struct, _1 )
# 5677 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1588 "parser_c.mly"
             ( Union, _1 )
# 5684 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1590 "parser_c.mly"
                        ( Struct, _1 (* TODO *) )
# 5692 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1591 "parser_c.mly"
                        ( Union, _1  (* TODO *) )
# 5700 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration) in
    Obj.repr(
# 1596 "parser_c.mly"
                     ( DeclarationField _1 )
# 5707 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1597 "parser_c.mly"
           ( EmptyField _1  )
# 5714 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1603 "parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 5725 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1607 "parser_c.mly"
     ( CppDirectiveStruct _1 )
# 5732 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1609 "parser_c.mly"
     ( IfdefStruct _1 )
# 5739 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'struct_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1614 "parser_c.mly"
     (
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing dont allow this";

       FieldDeclList (_2 +> (List.map (fun (f, iivirg) ->
         f returnType, iivirg))
                         ,[_3])
         (* dont need to check if typedef or func initialised cos
          * grammar dont allow typedef nor initialiser in struct
          *)
     )
# 5759 "parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1628 "parser_c.mly"
     (
       (* gccext: allow empty elements if it is a structdef or enumdef *)
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing dont allow this";

       FieldDeclList ([(Simple (None, returnType)) , []], [_2])
     )
# 5774 "parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorsd) in
    Obj.repr(
# 1643 "parser_c.mly"
     ( (fun x -> Simple   (Some (fst _1), (snd _1) x)) )
# 5781 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1645 "parser_c.mly"
     ( (fun x -> BitField (None, x, _1, _2)) )
# 5789 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratorsd) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1647 "parser_c.mly"
     ( (fun x -> BitField (Some (fst _1), ((snd _1) x), _2, _3)) )
# 5798 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1654 "parser_c.mly"
              ( (*also ? LP.add_ident (fst (fst $1)); *) _1 )
# 5805 "parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1656 "parser_c.mly"
                           ( _2 )
# 5813 "parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1657 "parser_c.mly"
                           ( _1 )
# 5821 "parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 's_or_u_spec2) in
    Obj.repr(
# 1662 "parser_c.mly"
                                   ( dt "su" (); _1 )
# 5828 "parser_c.ml"
               : 'struct_or_union_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union2) in
    Obj.repr(
# 1663 "parser_c.mly"
                                  ( et "su" (); _1 )
# 5835 "parser_c.ml"
               : 'struct_or_union))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl2) in
    Obj.repr(
# 1664 "parser_c.mly"
                           ( et "struct" (); _1 )
# 5842 "parser_c.ml"
               : 'struct_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1666 "parser_c.mly"
                 ( et "dotdot" (); _1 )
# 5849 "parser_c.ml"
               : 'dotdot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1667 "parser_c.mly"
                        ( dt "const_expr2" (); _1 )
# 5856 "parser_c.ml"
               : 'const_expr2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl_list) in
    Obj.repr(
# 1670 "parser_c.mly"
                     ( _1 )
# 5863 "parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    Obj.repr(
# 1671 "parser_c.mly"
                         ( [] )
# 5869 "parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1679 "parser_c.mly"
     ( Enum (None,    _3),           [_1;_2;_5] ++ _4 )
# 5880 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1681 "parser_c.mly"
     ( Enum (Some (fst _2), _4),     [_1; snd _2; _3;_6] ++ _5 )
# 5892 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1683 "parser_c.mly"
     ( EnumName (fst _2),       [_1; snd _2] )
# 5900 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'idente) in
    Obj.repr(
# 1686 "parser_c.mly"
                          ( _1, None     )
# 5907 "parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'idente) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1687 "parser_c.mly"
                          ( _1, Some (_2, _3) )
# 5916 "parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1694 "parser_c.mly"
                  ( LP.add_ident (str_of_name _1); _1 )
# 5923 "parser_c.ml"
               : 'idente))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_def) in
    Obj.repr(
# 1701 "parser_c.mly"
                                     ( fixFunc _1 )
# 5930 "parser_c.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1704 "parser_c.mly"
                  ( [_1 Ast_c.LocalDecl]   )
# 5937 "parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1705 "parser_c.mly"
                  ( _1 ++ [_2 Ast_c.LocalDecl] )
# 5945 "parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1709 "parser_c.mly"
                                    ( )
# 5952 "parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1710 "parser_c.mly"
                                    ( )
# 5960 "parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1713 "parser_c.mly"
                           ( LP.del_scope(); (_1, _2, None) )
# 5968 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1714 "parser_c.mly"
                                         ( LP.del_scope(); (_1, _3, None) )
# 5977 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1715 "parser_c.mly"
                                     (
     (* TODO: undo the typedef added ? *)
     LP.del_scope();
     (_1, _3, Some _2)
   )
# 5990 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'start_fun2) in
    Obj.repr(
# 1722 "parser_c.mly"
  ( LP.new_scope();
    fix_add_params_ident _1;
    (* toreput? !LP._lexer_hint.toplevel <- false;  *)
    _1
  )
# 6001 "parser_c.ml"
               : 'start_fun))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorfd) in
    Obj.repr(
# 1729 "parser_c.mly"
     ( let (returnType,storage) = fixDeclSpecForFuncDef _1 in
       let (id, attrs) = _2 in
       (fst id, fixOldCDecl ((snd id) returnType) , storage, attrs)
     )
# 6012 "parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_dtor) in
    Obj.repr(
# 1733 "parser_c.mly"
               ( _1 )
# 6019 "parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1736 "parser_c.mly"
                                (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, (([], (false, []))))) [_2;_3] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6034 "parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1743 "parser_c.mly"
                                                    (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, _3)) [_2;_4] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6050 "parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1764 "parser_c.mly"
              ( et "declaratorfd" (); _1, Ast_c.noattr )
# 6057 "parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1766 "parser_c.mly"
                           ( et "declaratorfd" (); _2, _1 )
# 6065 "parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1767 "parser_c.mly"
                           ( et "declaratorfd" (); _1, Ast_c.noattr )
# 6073 "parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : (Ast_c.info * bool ref)) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1777 "parser_c.mly"
     (
       let (i1, in_ifdef) = _1 in
       let (s, i2) = _2 in

       (* redo some lexing work :( *)
       let inc_file =
         match () with
         | _ when s =~ "^\"\\(.*\\)\"$" ->
             Local (Common.split "/" (matched1 s))
         | _ when s =~ "^\\<\\(.*\\)\\>$" ->
             NonLocal (Common.split "/" (matched1 s))
         | _ ->
             Weird s
       in
       Include { i_include = (inc_file, [i1;i2]);
                 i_rel_pos = Ast_c.noRelPos();
                 i_is_in_ifdef = !in_ifdef;
                 i_content = Ast_c.noi_content;
       }
     )
# 6100 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1799 "parser_c.mly"
     ( Define ((fst _2, [_1; snd _2;_4]), (DefineVar, _3)) )
# 6110 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'param_define_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1806 "parser_c.mly"
     ( Define
         ((fst _2, [_1; snd _2; _7]),
           (DefineFunc (_4, [_3;_5]), _6))
     )
# 6126 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1812 "parser_c.mly"
     ( Define((fst _2, [_1; snd _2; _3]), (Undef,DefineEmpty)) )
# 6135 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'pragmainfo) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1815 "parser_c.mly"
     ( Pragma((fst _2, [_1; snd _2; _4]), _3) )
# 6145 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1817 "parser_c.mly"
                      ( OtherDirective ([_1]) )
# 6152 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1820 "parser_c.mly"
                                ( (PragmaTuple (_2, [_1;_3])) )
# 6161 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1821 "parser_c.mly"
               ( PragmaTuple ([], [_1;_2]) )
# 6169 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_define_list_ne) in
    Obj.repr(
# 1822 "parser_c.mly"
                        ( PragmaIdList _1 )
# 6176 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1828 "parser_c.mly"
             ( DefineExpr _1 )
# 6183 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1829 "parser_c.mly"
             ( DefineStmt _1 )
# 6190 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1830 "parser_c.mly"
             ( DefineStmt (mk_st (Decl (_1 Ast_c.NotLocalDecl)) Ast_c.noii) )
# 6197 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1840 "parser_c.mly"
     ( let returnType = fixDeclSpecForMacro _1 in
       DefineType returnType
     )
# 6206 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1844 "parser_c.mly"
     ( let returnType = fixDeclSpecForMacro _1 in
       let typ = _2 returnType in
       DefineType typ
     )
# 6217 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1856 "parser_c.mly"
     ( DefineMulti
	 (List.map
	    (function
		StmtElem e -> e
	      | _ -> failwith "unexpected statement for DefineMulti")
	    (_1 :: _2)) )
# 6230 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1870 "parser_c.mly"
                       ( DefineFunction _1 )
# 6237 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'comma_opt) in
    Obj.repr(
# 1873 "parser_c.mly"
    ( DefineInit (InitList (List.rev _2), [_1;_4]++_3++_5)  )
# 6248 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1877 "parser_c.mly"
     (
       (* TOREPUT
       if fst $5 <> "0"
       then pr2 "WEIRD: in macro and have not a while(0)";
       *)
       DefineDoWhileZero ((_2,_5),   [_1;_3;_4;_6])
     )
# 6266 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1885 "parser_c.mly"
                                         ( DefineTodo )
# 6276 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1886 "parser_c.mly"
                                         ( DefineTodo )
# 6287 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1889 "parser_c.mly"
              ( DefineTodo )
# 6294 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    Obj.repr(
# 1891 "parser_c.mly"
                   ( DefineEmpty )
# 6300 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1897 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6307 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1898 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6314 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1899 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6321 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1900 "parser_c.mly"
                        ( "...", [_1] )
# 6328 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1902 "parser_c.mly"
                        ( "register", [_1] )
# 6335 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 1909 "parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((Ifdef, IfdefTag (Common.some !tag)),  [ii]) )
# 6343 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 1912 "parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefElse, IfdefTag (Common.some !tag)), [ii]) )
# 6351 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 1915 "parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefElseif, IfdefTag (Common.some !tag)), [ii]) )
# 6359 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 1918 "parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefEndif, IfdefTag (Common.some !tag)), [ii]) )
# 6367 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 1922 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef, IfdefTag (Common.some !tag)), [ii]) )
# 6375 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 1925 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef, IfdefTag (Common.some !tag)), [ii]) )
# 6383 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 1928 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef, IfdefTag (Common.some !tag)), [ii]) )
# 6391 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1939 "parser_c.mly"
     (
       Declaration(MacroDecl((fst _1, _3, true), [snd _1;_2;_4;_5;fakeInfo()]))
       (* old: MacroTop (fst $1, $3,    [snd $1;$2;$4;$5])  *)
     )
# 6405 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1946 "parser_c.mly"
     ( Declaration (MacroDecl ((fst _1, _3, false), [snd _1;_2;_4;fakeInfo()])) )
# 6415 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1949 "parser_c.mly"
                      ( EmptyDef [snd _1;_2] )
# 6423 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1958 "parser_c.mly"
                                     ( Definition _1 )
# 6430 "parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1959 "parser_c.mly"
                                     ( Declaration (_1 Ast_c.NotLocalDecl) )
# 6437 "parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1964 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; 
       Namespace (_4, [_1; snd _2; _3; _5]) )
# 6449 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 1967 "parser_c.mly"
                                                ( _1 )
# 6456 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1971 "parser_c.mly"
     ( CppTop _1 )
# 6463 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_other) in
    Obj.repr(
# 1973 "parser_c.mly"
     ( _1 )
# 6470 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1975 "parser_c.mly"
     ( IfdefTop _1 )
# 6477 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1978 "parser_c.mly"
                                                ( EmptyDef [_1;_2;_4;_5] )
# 6488 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1985 "parser_c.mly"
              ( EmptyDef [_1] )
# 6495 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1988 "parser_c.mly"
              ( FinalDef _1 )
# 6502 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1997 "parser_c.mly"
                  ( LP.push_context LP.InFunction; LP.new_scope (); _1 )
# 6509 "parser_c.ml"
               : 'tobrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1998 "parser_c.mly"
                  ( LP.pop_context();              LP.del_scope (); _1 )
# 6516 "parser_c.ml"
               : 'tcbrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2000 "parser_c.mly"
                      ( LP.push_context LP.InEnum; _1 )
# 6523 "parser_c.ml"
               : 'tobrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2001 "parser_c.mly"
                      ( LP.pop_context (); _1 )
# 6530 "parser_c.ml"
               : 'tcbrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2003 "parser_c.mly"
                     ( LP.push_context LP.InInitializer; _1 )
# 6537 "parser_c.ml"
               : 'tobrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2004 "parser_c.mly"
                     ( LP.pop_context (); _1 )
# 6544 "parser_c.ml"
               : 'tcbrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2006 "parser_c.mly"
                        ( LP.push_context LP.InStruct; _1)
# 6551 "parser_c.ml"
               : 'tobrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2007 "parser_c.mly"
                        ( LP.pop_context (); _1 )
# 6558 "parser_c.ml"
               : 'tcbrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2013 "parser_c.mly"
     ( LP.new_scope ();et "topar" ();
       LP.push_context LP.InParameter;
       _1
     )
# 6568 "parser_c.ml"
               : 'topar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2018 "parser_c.mly"
     ( LP.del_scope ();dt "tcpar" ();
       LP.pop_context ();
       _1
     )
# 6578 "parser_c.ml"
               : 'tcpar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2057 "parser_c.mly"
               ( _1 )
# 6585 "parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2058 "parser_c.mly"
                           ( _1 ++ _2 )
# 6593 "parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2061 "parser_c.mly"
             ( [_1] )
# 6600 "parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'colon_asm_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2062 "parser_c.mly"
                             ( _1 ++ [_2] )
# 6608 "parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2065 "parser_c.mly"
                ( [_1, []] )
# 6615 "parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'colon_option_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2066 "parser_c.mly"
                                         ( _1 ++ [_3, [_2]] )
# 6624 "parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument_ne) in
    Obj.repr(
# 2070 "parser_c.mly"
                                         ( [_1, []] )
# 6631 "parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2071 "parser_c.mly"
                                    ( _1 ++ [_3,    [_2]] )
# 6640 "parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2074 "parser_c.mly"
                                      ( [_1, []] )
# 6647 "parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2075 "parser_c.mly"
                                 ( _1 ++ [_3,    [_2]] )
# 6656 "parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2085 "parser_c.mly"
                             ( [RegularName (mk_string_wrap _1), []] )
# 6663 "parser_c.ml"
               : 'ident_define_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_define_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2087 "parser_c.mly"
     ( _1 ++ [RegularName (mk_string_wrap _2), []] )
# 6671 "parser_c.ml"
               : 'ident_define_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2091 "parser_c.mly"
                                 ( [_1] )
# 6678 "parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2092 "parser_c.mly"
                                 ( _1 ++ [_2] )
# 6686 "parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2096 "parser_c.mly"
                                                   ( [_1,           []] )
# 6693 "parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2097 "parser_c.mly"
                                                   ( _1 ++ [_3,     [_2]] )
# 6702 "parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2101 "parser_c.mly"
                                     ( [_1,          []]   )
# 6709 "parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2102 "parser_c.mly"
                                     ( _1 ++ [_3,    [_2]] )
# 6718 "parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2106 "parser_c.mly"
                                               ( [_1,   []] )
# 6725 "parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2107 "parser_c.mly"
                                               ( _1 ++ [_3,     [_2]] )
# 6734 "parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2111 "parser_c.mly"
                                        ( [_1, []] )
# 6741 "parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2112 "parser_c.mly"
                                        ( _1 ++ [_3,  [_2]] )
# 6750 "parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2115 "parser_c.mly"
                           ( [_1] )
# 6757 "parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 2116 "parser_c.mly"
                           ( _1 :: _2 )
# 6765 "parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    Obj.repr(
# 2124 "parser_c.mly"
                        ( [] )
# 6771 "parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 2125 "parser_c.mly"
                        ( _1 :: _2 )
# 6779 "parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 2128 "parser_c.mly"
                   ( [] )
# 6785 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2129 "parser_c.mly"
                                          ( [_1, []] )
# 6792 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'param_define_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2130 "parser_c.mly"
                                          ( _1 ++ [_3, [_2]] )
# 6801 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2133 "parser_c.mly"
              ( [_1] )
# 6808 "parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2134 "parser_c.mly"
                              ( _1 ++ [_2] )
# 6816 "parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2137 "parser_c.mly"
             ( [_1] )
# 6823 "parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2138 "parser_c.mly"
                            ( _1 ++ [_2] )
# 6831 "parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_storage) in
    Obj.repr(
# 2141 "parser_c.mly"
                     ( [_1] )
# 6838 "parser_c.ml"
               : 'attribute_storage_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_storage_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_storage) in
    Obj.repr(
# 2142 "parser_c.mly"
                                            ( _1 ++ [_2] )
# 6846 "parser_c.ml"
               : 'attribute_storage_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_list) in
    Obj.repr(
# 2145 "parser_c.mly"
                           ( _1 )
# 6853 "parser_c.ml"
               : 'attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2151 "parser_c.mly"
          (  [_1] )
# 6860 "parser_c.ml"
               : 'gcc_comma_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2152 "parser_c.mly"
                    (  []  )
# 6866 "parser_c.ml"
               : 'gcc_comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2155 "parser_c.mly"
          (  [_1] )
# 6873 "parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2156 "parser_c.mly"
                    (  []  )
# 6879 "parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2165 "parser_c.mly"
               ( Some _1 )
# 6886 "parser_c.ml"
               : 'gcc_opt_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 2166 "parser_c.mly"
                   ( None  )
# 6892 "parser_c.ml"
               : 'gcc_opt_expr))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry celem *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry statement *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry expr *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry type_name *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Ast_c.program)
let celem (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 2 lexfun lexbuf : Ast_c.toplevel)
let statement (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 3 lexfun lexbuf : Ast_c.statement)
let expr (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 4 lexfun lexbuf : Ast_c.expression)
let type_name (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 5 lexfun lexbuf : Ast_c.fullType)
